Package: epivizr
Maintainer: Hector Corrada Bravo <hcorrada@gmail.com>
Author: Hector Corrada Bravo, Florin Chelaru, Llewellyn Smith, Naomi
    Goldstein, Jayaram Kancherla, Morgan Walter, Brian Gottfried
Version: 2.42.0
License: Artistic-2.0
Title: R Interface to epiviz web app
Description: This package provides connections to the
    epiviz web app (http://epiviz.cbcb.umd.edu) for interactive
    visualization of genomic data. Objects in R/bioc interactive
    sessions can be displayed in genome browser tracks or plots to
    be explored by navigation through genomic regions. Fundamental
    Bioconductor data structures are supported (e.g., GenomicRanges
    and RangedSummarizedExperiment objects), while providing an easy
    mechanism to support other data structures (through package epivizrData).
    Visualizations (using d3.js) can be easily added to the web app as well.
VignetteBuilder: knitr
Depends: R (>= 3.5.0), methods
Imports: epivizrServer (>= 1.1.1), epivizrData (>= 1.3.4),
        GenomicRanges, S4Vectors, IRanges, bumphunter, GenomeInfoDb
Suggests: testthat, roxygen2, knitr, Biobase, SummarizedExperiment,
        antiProfilesData, hgu133plus2.db, Mus.musculus, BiocStyle,
        minfi, rmarkdown
Collate: 'EpivizChartMgr-class.R' 'EpivizApp-class.R'
        'EpivizChart-class.R' 'restartEpiviz.R' 'settings_utils.R'
        'startEpiviz.R' 'vignette_data.R'
biocViews: Visualization, Infrastructure, GUI
Video: https://www.youtube.com/watch?v=099c4wUxozA
RoxygenNote: 7.1.0
git_url: https://git.bioconductor.org/packages/epivizr
git_branch: RELEASE_3_23
git_last_commit: 9cd98d7
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:59:15 UTC; biocbuild

epivizR
========

The `epivizr` Bioconductor package implements two-way communication between the [R/Bioconductor](http://bioconductor.org) environment and the [epiviz](http://epiviz.cbcb.umd.edu) web app for interactive data visualization. Objects in the R environment can be displayed as tracks or plots on Epiviz. Epivizr uses Websockets for communication between the browser Javascript client and the R environment using the same technology underlying the popular [Shiny](http://www.rstudio.com/shiny) system for authoring interactive web-based reports in R.

## Installation and requirements
Epivizr is available as part of the [Bioconductor](http://bioconductor.org) project as of version 2.13. To install the release version of `epivizr`:

```{r}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("epivizr")
```

## Development version

This github repository contains the latest and greatest version of `epivizr` and is tracked by the devel version in Bioconductor (see
[http://bioconductor.org/developers/how-to/useDevel/](http://bioconductor.org/developers/how-to/useDevel/) for more info. 

## Try it out

The easiest way to try `epivizr` out is to follow the package vignette:

```{r}
require(epivizr)
browseVignettes("epivizr")
```

## A quick tour

You can get a quick tour of epiviz here: [http://youtu.be/099c4wUxozA](http://youtu.be/099c4wUxozA)

## Non-blocking

As of version 1.3, Epivizr supports a non-blocking workflow on both UNIX-like and Windows systems where data is served to the webapp without blocking
the R/bioc interactive session. Make sure you are using the latest version of the [httpuv package](http://cran.r-project.org/web/packages/httpuv/index.html) to use this. (Thanks to the
[Rstudio](http://rstudio.org) folks for folding our daemonizing code into the main httpuv release).

## More info

Check out the `epiviz` [project page on github](http:://github.com/epiviz), and the
[documentation page](http://epiviz.github.io).

.constructURL <- function(host=NULL, http_port=NULL, path = NULL, ws_host="localhost", ws_port=7123L,
                          use_devel=FALSE, debug=FALSE, 
                          chr="chr11", start=99800000, end=103383180,
                          workspace=NULL, scripts=NULL, gists=NULL, use_cookie=FALSE)
{
  if (is.null(host)) {
    host <- ifelse(use_devel,"epiviz-dev", "epiviz")
    host <- sprintf("http://%s.cbcb.umd.edu", host)
  }
  
  if (!is.null(http_port)) {
    port <- sprintf(":%d", http_port)
  } else {
    port <- ""
  }
  
  if (is.null(path)) {
    path <- "/index.php"
  }
  
  url <- paste0(host,port,path)
  controllerHost <- sprintf("ws://%s:%d", ws_host, ws_port)  
  url <- sprintf("%s?websocket-host[]=%s&", url, controllerHost)
  url <- paste0(url, sprintf("debug=%s&", ifelse(debug, "true", "false")))
  
  if (!is.null(workspace)) {
    url <- paste0(url,"ws=",workspace,"&")
  } else if (!is.null(chr) && !is.null(start) && !is.null(end)) {
    url <- paste0(url,
                  sprintf("seqName=%s&start=%d&end=%d&",
                          chr,
                          as.integer(start),
                          as.integer(end)))
  }
  
  if (!is.null(scripts)) {
    script_string <- paste(sprintf("script[]=%s&", scripts),collapse="")
    url <- paste0(url, script_string)
  }
  
  if (!is.null(gists)) {
    gist_string <- paste(sprintf("gist[]=%s&", gists), collapse="")
    url <- paste0(url, gist_string)
  }
  
  cookie_string <- sprintf("useCookie=%s&", ifelse(use_cookie, "true", "false"))
  url <- paste0(url, cookie_string)
  url
}

#' Class managing connection to epiviz application.
#' 
#' @field server An object of class [`EpivizServer`] used to communicate with epiviz app.
#' @field data_mgr An object of class [`EpivizDataMgr`] used to serve data to epiviz app.
#' @field chart_mgr An object of class [`EpivizChartMgr`] used to manage charts added to epiviz app session.
#' 
#' @importClassesFrom epivizrServer EpivizServer
#' @importClassesFrom epivizrData EpivizDataMgr EpivizMeasurement EpivizData
#' @import GenomicRanges 
#' @import S4Vectors
#' @import methods
#' @import IRanges
#' 
#' @include EpivizChartMgr-class.R
#' @exportClass EpivizApp
#' @md
EpivizApp <- setRefClass("EpivizApp",
  fields=list(
    .url_parms="list",
    .browser_fun="function",
    server="EpivizServer",
    data_mgr="EpivizDataMgr",
    chart_mgr="EpivizChartMgr"
  ),
  methods=list(
   show=function() {
     "Print information about app connection."
      cat("Epiviz App connection:\n")
      cat("Server: ")
      server$show(); cat("\n")

      st <- .self$chart_mgr$list_charts()
      if (!is.null(st)) {
        cat("Charts:\n")
        print(st); cat("\n")
      }

      st <- .self$data_mgr$list_measurements()
      if (length(st)>0) {
        cat("Measurements:\n")
        print(st); cat("\n")
      }
   },
   is_server_closed=function() {
     "Check if underlying server connection is closed."
     is.null(.self$server) || .self$server$is_closed()
   }
  )
)

# general plot method
EpivizApp$methods(
  get_ms_object = function(chart_id_or_object, index=1) {
    "Get object of class \\code{\\link[epivizrData]{EpivizData}} used as a data source
    in a given chart.
    
    \\describe{
      \\item{chart_id_or_object}{An object of class \\code{EpivizChart} or an id for
        a chart loaded to the epiviz app.}
      \\item{index}{Index into \\code{.measurements}} list of chart object to obtain data object for.
    }"
    chart_object <- .self$chart_mgr$.get_chart_object(chart_id_or_object)
    measurements <- chart_object$.measurements
    if (index < 1 || index > length(measurements)) {
      stop("'index' out of range")
    }
    measurement <- measurements[[index]]
    datasource <- measurement@datasourceId
    .self$data_mgr$.find_datasource(datasource)
  },
  plot = function(data_object, datasource_name=NULL, send_request=TRUE, settings=NULL, colors=NULL, ...) {
    "Visualize data on epiviz app using its default chart type. Measurements from the \\code{data-object} 
    are first added to the epiviz app using the \\code{add_measurements} method for class 
    \\code{\\link[epivizrData]{EpivizData}}. See documentation for \\code{\\link[epivizrData]{register}}
    for information on supported data types and the \\code{\\link[epivizrData]{EpivizData}} class
    encapsulating this type of data. Once measurements are loaded, the \\code{\\link{plot}} method
    of class \\code{\\link{EpivizChartMgr}} is used to plot the data, using the default chart type
    for this type of data.
    
    \\describe{
      \\item{data_object}{An object to plot in epiviz app.}
      \\item{datasource_name}{Name to use for datasource, parses \\code{data_object} if missing or NULL}
      \\item{...}{Additional arguments passed to \\code{add_measurements} method for class
        \\code{\\link[epivizrData]{EpivizData}}}
    }"
    datasource_origin_name <- deparse(substitute(data_object))
    if (missing(datasource_name)) {
      datasource_name <- datasource_origin_name
    }
    ms_obj <- .self$data_mgr$add_measurements(data_object, 
                                              datasource_name=datasource_name,
                                              datasource_origin_name=datasource_origin_name,
                                              send_request=send_request, ...)
    .self$server$wait_to_clear_requests()
    
    if (send_request && .self$server$is_interactive() && !.self$data_mgr$is_ms_connected(ms_obj)) {
      stop("Error adding measurements for data object\n")
    }
    .self$chart_mgr$plot(ms_obj, send_request=send_request, settings=settings, colors=colors)
  }
)

# # navigation methods
EpivizApp$methods(
  navigate=function(chr, start, end) {
    'Navigate to given position on the epiviz app.'
    if (.self$is_server_closed()) {
      return(invisible())
    }
    
    callback <- function(response_data) {
      invisible()
    }
    request_data=list(action="navigate",
      range=epivizrServer::json_writer(
        list(seqName=chr,start=start,end=end)))
    .self$server$send_request(request_data, callback)
  },
  get_current_location=function(callback) {
    'Obtain current genome location on epiviz app and evaluate callback
    function on result.
    
    \\describe{
      \\item{callback}{A callback function to evaluate on response data. 
        Response data will be a list with slots \\code{seqName}, \\code{start}
        and \\code{end}}
    }'
    request_data=list(action="getCurrentLocation")
    .self$server$send_request(request_data, callback)
  },
  slideshow=function(granges, n=length(granges), .callback=NULL) {
    'Navigate on epiviz app successively to given positions.
    
    \\describe{
      \\item{granges}{An object of class \\code{\\link{GenomicRanges}} indicating
        set of genomic regions to navigate in epiviz app.}
      \\item{n}{(integer) The number of regions in \\code{granges} to navigate to.}
      \\item{.callback}{(function) function to call after navigating to each region. Used for testing purposes.}
    }'
    if (!is(granges, "GenomicRanges"))
      stop(("'granges' must be a 'GenomicRanges' object"))

    n <- min(n, length(granges))
    ind <- seq(len=n)
    chr <- as.character(seqnames(granges)[ind])
    start <- start(granges)[ind]
    end <- end(granges)[ind]
    for (i in ind) {
      .self$navigate(chr=chr[i], start=start[i], end=end[i])
      if (!is.null(.callback) && is.function(.callback)) {
        .callback(chr[i], start[i], end[i])
      } else {
        if (.self$server$is_interactive()) {
          cat("Region", i, "of", n, ". Press key to continue (ESC to stop)...\n")
          readLines(n=1)
        }
      }
      tryCatch(.self$server$service(), interrupt=function(int) invisible())
    }
    invisible()
  }
)

# data update methods
EpivizApp$methods(
  update_measurements = function(ms_object, new_data_object, send_request = TRUE) {
    .self$data_mgr$update_measurements(ms_object, new_data_object, send_request = send_request)
    .self$chart_mgr$.redraw(send_request = send_request)
  },
  load_remote_measurements = function() {
    "Load remote measurements into R session."
    callback=function(data) {
      .self$data_mgr$set_remote_measurements(data$measurements)
    }
    
    request_data <- list(action = "loadMeasurements")
    .self$server$send_request(request_data, callback)
    invisible()
  }
)

# session management methods
EpivizApp$methods(
  .wait_for_connection = function(timeout=10L) {
    if (.self$server$.verbose) {
      cat("Servicing websocket until connected\n")
    }
    
    ptm <- proc.time()["elapsed"]
    while(!.self$server$is_socket_connected() && (proc.time()["elapsed"] - ptm  < timeout)) {
      .self$service(verbose=FALSE)
    }
    
    if (!.self$server$is_socket_connected()) {
      stop("[epivizr] Error opening connection. UI unable to connect to websocket server.")
    }
  },
  .open_browser=function() {
    close_on_error <- FALSE
    if (.self$is_server_closed()) {
      close_on_error <- TRUE
      if (.self$server$.verbose) {
        cat("Starting epiviz websocket connection\n")
      }
      tryCatch(.self$server$start_server(),
               error=function(e) stop(e))
    }

    if (!.self$server$is_interactive()) {
      return(invisible())
    }

    if (.self$server$.verbose) {
      cat("Opening browser\n")
    }

    tryCatch({
      .self$.url_parms$ws_port <- .self$server$.port
      url <- do.call(.constructURL, .self$.url_parms)
      
      if(.self$server$.verbose) {
        cat("Using url ", url, "\n")
      }
      
      .self$.browser_fun(url)
      if (.self$server$is_daemonized()) {
        return(invisible())
      }
      .self$.wait_for_connection()      
    }, error=function(e) {
      if (close_on_error) .self$server$stop_server()
      stop(e)
    })
  },
  load_workspace=function(workspace_id=NULL) {
    "load an epiviz workspace.

    \\describe{
      \\item{workspace_id}{Workspace id to load from the database.}
    }"
    callback=function(data) {
      cat("workspace: ", workspace_id  ," is being loaded \n")
    }
    
    request_data <- list(action = "loadWorkspace", workspaceId=workspace_id)
    .self$server$send_request(request_data, callback)
    invisible()
  },
  print_workspace=function(file_name=NULL, file_type="pdf"){
    "Save epiviz workspace as a pdf or png."
    callback=function(data) {
      cat("workspace is being saved as", file_type, "\n")
    }
    
    request_data <- list(action = "printWorkspace", fileName=file_name, fileType=file_type)
    .self$server$send_request(request_data, callback)
    invisible()
  },
  service=function(verbose=TRUE) {
    "Block interactive R session to service websocket requests."
    if (verbose && .self$server$is_interactive() && !.self$server$is_daemonized()) {
      cat("Serving Epiviz, escape to continue interactive session...\n")
    }

    .self$server$service()
  },
  .stop_service=function() {
    .self$server$stop_service()
  },
  stop_app=function() {
    'stop and clean connection to epiviz app.'
    .self$chart_mgr$rm_all_charts()
    .self$server$wait_to_clear_requests()
    .self$data_mgr$rm_all_measurements()
    .self$server$wait_to_clear_requests()
    .self$server$stop_server()
    invisible()
  }
)

# save method
EpivizApp$methods(
  save = function(file, include_data=TRUE) {
    "Save EpivizApp object representation of a workspace into .RData file.

    \\describe{
      \\item{file}{(character) The name of the file to save the EpivizApp object into, ending in .rda.}
      \\item{stop_app}{(logical) Stop the EpivizApp session.}
      \\item{include_data}{(logical) Include EpivizApp's data when saving the EpivizApp object.}
    }"
    if (!is(.self, "EpivizApp")) {
      stop("'app' must be an 'EpivizApp' object")
    }
    
    if (.self$server$is_interactive() && !.self$is_server_closed()) {
      .self$get_current_location(function(response) {
        if (response$success) {
          loc <- response$value
          .self$.url_parms$chr <- loc$seqName
          .self$.url_parms$start <- loc$start
          .self$.url_parms$end <- loc$end
        }
      })
    }
    
    if (!include_data) {
      ms_ids <- ls(envir=.self$data_mgr$.ms_list)
      
      ms_ids_objs <- lapply(ms_ids, function(id) {
        ms_obj <- .self$data_mgr$.get_ms_object(id)
        c(id, ms_obj$.object)
      })

      lapply(ms_ids, function(id) {
        ms_obj <- .self$data_mgr$.get_ms_object(id)
        ms_obj$.object <- NULL
      })
    }
    
    app <- .self
    base::save(app, file=file)   
    
    if (!include_data) {
      # Add data back to ms object
       for (id_obj in ms_ids_objs) {
         id <- id_obj[[1]]
         obj <- id_obj[[2]]
         ms_obj <- .self$data_mgr$.get_ms_object(id)
         ms_obj$.object <- obj
      }
    }
})

  

context("disconnected app data update")

test_that("disconnected data update through app works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  gr2 <- GenomicRanges::GRanges(seqnames="chr12", ranges=IRanges::IRanges(start=1:1000,width=10))
  
  chart_mgr$register_chart_type("BlocksTrack")
  chart_obj <- app$plot(gr, datasource_name="ms1", send_request=FALSE)
  chart_id <- chart_obj$get_id()
  
  ms_obj <- app$get_ms_object(chart_obj)
  
  app$update_measurements(ms_obj, gr2)

  ms_obj2 <- app$get_ms_object(chart_obj)
  expect_identical(as(ms_obj2$.object, "GRanges"), gr2)
})

context("browser commands")

test_that("navigate works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  app$navigate(chr="chr10", start=2000, end=10000)
})

test_that("slideshow works", {
  server <- epivizrServer::createServer(non_interactive=TRUE)
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  app <- EpivizApp$new(server=server,
    data_mgr=data_mgr,
    chart_mgr=chart_mgr)
  
  granges <- GenomicRanges::GRanges("chr10", 
    IRanges::IRanges(start=(1:10)*1000, width=10000))
  expect_error(app$slideshow(granges, n=4))
})

#' Restart epiviz app connection and workspace.
#'
#' @param file (character) The name of the file that holds the EpivizApp object to be restarted, ending in .rda.
#' @param open_browser (logical) browse to the epiviz URL before exiting function.
#' @param host (character) name of epiviz app host to open at restart
#' @param envir (environment) environment in which to evaluate expressions needed to reconstruct data sources
#' 
#' @return An object of class \code{\link{EpivizApp}}
#'
#' @examples
#' # see package vignette for example usage
#' app <- startEpiviz(non_interactive=TRUE, open_browser=TRUE)
#' file_name <- tempfile(fileext=".rda")
#' app$save(file=file_name)
#' app$stop_app()
#' 
#' app <- restartEpiviz(file=file_name, open_browser=FALSE)
#'
#' @export
restartEpiviz <- function(file, open_browser=TRUE, host=NULL, envir=parent.frame()) {
  
  if (!file.exists(file)) {
    stop("File does not exist")
  }

  load_env <- new.env()  
  load(file=file, envir=load_env)
  app <- get("app", load_env)
  
  if (open_browser) {
    app$server$start_server()    
    app$service()
  }
  
  if(!is.null(host)) {
    app$.url_parms$host <- host
  }
  
  ms_ids <- ls(envir=app$data_mgr$.ms_list)
  data_not_in_envir <- FALSE
  
  # If file is saved without data, this will
  # update data into Epiviz App if it exists
  # in environment
  for (id in ms_ids){
    ms_obj <- app$data_mgr$.get_ms_object(id)
    
    if (is.null(ms_obj$.object)) {
      new_obj <- tryCatch({
        eval(parse(text=ms_obj$get_source_name()), envir=envir)
      }, error = function(e) {
        # instead of stopping here, this warns 
        # of all datasources not in environment
        datasource_name <- ms_obj$get_source_name()
        warning("Couldn't evaluate the expression: ", datasource_name)     
        return(NULL)
      })
      
      if (is.null(new_obj)) {
        data_not_in_envir <- TRUE
      } else {
        ms_obj$update(new_obj)
      }
    } 
  }
  
  if (data_not_in_envir) {
    app$server$stop_server()
    stop("Load data in environment before restarting.")
  }
  
  if (open_browser) {
    app$.open_browser()
    
    callback <- function(response_data) {
      if (app$server$.verbose) {
        if(response_data$success){
          cat("UI is READY \n")       
        } else {
          cat("UI is NOT READY \n")
        }
      }
    }
    
    request_data <- list(action="uiStatus")
    app$server$send_request(request_data, callback)
  
    tryCatch({
      app$server$wait_to_clear_requests()
    }, error = function(e) {
      app$server$stop_server()
      stop(e)
    })
    
  }
  
  app$chart_mgr$redraw_charts()
  return(app)
}

.settings_as_df <- function(chart_settings) {
  ids <- sapply(chart_settings, function(x) x$id)
  labels <- sapply(chart_settings, function(x) x$label)
  values <- sapply(chart_settings, function(x) x$defaultValue)
  poss_values <- sapply(chart_settings, function(x) {
    paste0(x$possibleValues, collapse=",")
  })
  types <- sapply(chart_settings, function(x) x$type)
  out <- data.frame(id=ids,
                    label=labels,
                    default_value=values,
                    possible_values=poss_values,
                    type=types,
                    stringsAsFactors=FALSE)
  out
}

#' Example methylation data (blocks) for epivizr vignette.
#' 
#' Example results from methylation analysis of human chromosome 11 using the [`minfi::minfi-package`] package 
#' of TCGA 450k beadarray samples. This object contains large regions of methylation difference between tumor 
#' and normal samples obtained from [`minfi::blockFinder()`].
#' 
#' @format A [`GRanges`] object with 129 and \code{mcols}:
#' 
#' \describe{
#'  \item{\code{value}}{average smooth methylation difference within block}
#'  \item{\code{area}}{block area estimate (abs(value) * length)}
#'  \item{\code{cluster}}{id of cluster blockgroup within which block occurs}
#'  \item{\code{indexStart}}{index of first cluster in block}
#'  \item{\code{indexEnd}}{index of last cluster in block}
#'  \item{\code{L}}{number of clusters in block}
#'  \item{\code{clusterL}}{number of probes in block}
#'  \item{\code{p.value}}{permutation p.value based on difference conditioned on length}
#'  \item{\code{fwer}}{family-wise error rate estimate based on difference conditioned on length}
#'  \item{\code{p.valueArea}}{permutation p.value based on area}
#'  \item{\code{fwerArea}}{family-wise error rate estimate based on area}
#' }
#' @source TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
#' @name tcga_colon_blocks
#' @docType data
#' @usage data(tcga_colon_blocks)
#' @md
NULL

#' Example methylation data (smoothed methylation levels) for epivizr vignette
#' 
#' Example results from methylation analysis of human chromosome 11 using the [`minfi::minfi-package`] package 
#' of TCGA 450k beadarray samples. This object contains probe cluster level methylation estimates from 
#' [`minfi::blockFinder()`].
#' 
#' @format A [`GRanges`] object with 7135 ranges and \code{mcols}:
#'
#' \describe{
#'  \item{\code{id}}{probe cluster id}
#'  \item{\code{type}}{probe cluster type}
#'  \item{\code{blockgroup}}{probe cluster block group}
#'  \item{\code{diff}}{raw methylation percentage difference between normal and tumor}
#'  \item{\code{smooth}}{smooth methylation percentage difference between normal and tumor}
#'  \item{\code{normalMean}}{mean methylation estimate for normal samples}
#'  \item{\code{cancerMean}}{mean methylation estimate for cancer samples} 
#' }
#' 
#' @source TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
#' @docType data
#' @name tcga_colon_curves
#' @usage data(tcga_colon_curves)
#' @md
NULL

#' Example exon-level RNAseq data from TCGA project for epivizr vignette.
#' 
#' A [`SummarizedExperiment::RangedSummarizedExperiment`] object containing exon-level
#' counts from RNAseq data for colon tumor and normal tissue from the TCGA project. 
#' Only exons in human chromosome 11 are included.
#' 
#' @format A [`SummarizedExperiment::RangedSummarizedExperiment`] object with 12,800 rows (exons) and 40 samples.
#'  \describe{
#'    \item{\code{assay(tcga_colon_expression)}}{exon-level count matrix}
#'    \item{\code{colData(tcga_colon_expression)}}{a \code{DataFrame} containing sample information. 
#'      Normal/Tumor status is given in column \code{sample_type}}
#'  }
#'  
#' @source TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
#' @return A [`SummarizedExperiment::RangedSummarizedExperiment`] object.
#' @docType data
#' @name tcga_colon_expression
#' @usage data(tcga_colon_expression)
#' @md
NULL

## ----eval=TRUE, echo=TRUE, results='hide', warning=FALSE, error=FALSE, message=FALSE----
library(epivizr)
library(antiProfilesData)
library(SummarizedExperiment)

## -----------------------------------------------------------------------------
data(tcga_colon_blocks)
data(tcga_colon_curves)
data(apColonData)

## -----------------------------------------------------------------------------
show(tcga_colon_blocks)

## ----fig.width=4, fig.height=4, fig.align='center'----------------------------
plot(tcga_colon_blocks$value, -log10(tcga_colon_blocks$p.value), main="Volcano plot", xlab="Avg. methylation difference", ylab="-log10 p-value",xlim=c(-.5,.5))

## -----------------------------------------------------------------------------
show(tcga_colon_curves)

## ----eval=FALSE, echo=TRUE----------------------------------------------------
# app <- startEpiviz(workspace="qyOTB6vVnff", gists="2caf8e891201130c7daa")

## ----eval=TRUE, echo=FALSE----------------------------------------------------
app <- startEpiviz(host="http://localhost", http_port=8989, debug=TRUE, open_browser=FALSE, non_interactive=TRUE, try_ports=TRUE)


# register BlockTrack
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 25, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 23, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 20, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 10, label = "Right margin", possibleValues = NULL), list(id = "minBlockDistance", type = "number", defaultValue = 5, label = "Minimum block distance", possibleValues = NULL))

js_chart_colors = c("#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf")

app$chart_mgr$register_chart_type("BlocksTrack", "epiviz.plugins.charts.BlocksTrack", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

# register LineTrack
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 25, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 23, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 20, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 10, label = "Right margin", possibleValues = NULL), list(id = "measurementGroupsAggregator", type = "categorical", defaultValue = "mean-stdev", label = "Aggregator for measurement groups", possibleValues = c("mean-stdev", "quartiles", "count", "min", "max", "sum")), list(id = "step", type = "number", defaultValue = 50, label = "Step", possibleValues = NULL), list(id = "showPoints", type = "boolean", defaultValue = FALSE, label = "Show points", possibleValues = NULL), list(id = "showLines", type = "boolean", defaultValue = TRUE, label = "Show lines", possibleValues = NULL), list(id = "showErrorBars", type = "boolean", defaultValue = TRUE, label = "Show error bars", possibleValues = NULL), list(id = "pointRadius", type = "number", defaultValue = 1, label = "Point radius", possibleValues = NULL), list(id = "lineThickness", type = "number", defaultValue = 1, label = "Line thickness", possibleValues = NULL), list(id = "yMin", type = "number", defaultValue = "default", label = "Min Y", possibleValues = NULL), list(id = "yMax", type = "number", defaultValue = "default", label = "Max Y", possibleValues = NULL), list(id = "interpolation", type = "categorical", defaultValue = "linear", label = "Interpolation", possibleValues = c("linear", "step-before", "step-after", "basis", "basis-open", "basis-closed", "bundle", "cardinal", "cardinal-open", "monotone")))

js_chart_colors <- c("#1859a9", "#ed2d2e", "#008c47", "#010101", "#f37d22", "#662c91", "#a11d20", "#b33893")

app$chart_mgr$register_chart_type("LineTrack", "epiviz.plugins.charts.LineTrack", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

# register ScatterPlot
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 15, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 50, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 50, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 15, label = "Right margin", possibleValues = NULL), list(id = "measurementGroupsAggregator", type = "categorical", defaultValue = "mean-stdev", label = "Aggregator for measurement groups", possibleValues = c("mean-stdev", "quartiles", "count", "min", "max", "sum")), list(id = "circleRadiusRatio", type = "number", defaultValue = 0.015, label = "Circle radius ratio", possibleValues = NULL), list(id = "xMin", type = "number", defaultValue = "default", label = "Min X", possibleValues = NULL), list(id = "xMax", type = "number", defaultValue = "default", label = "Max X", possibleValues = NULL), list(id = "yMin", type = "number", defaultValue = "default", label = "Min Y", possibleValues = NULL), list(id = "yMax", type = "number", defaultValue = "default", label = "Max Y", possibleValues = NULL))

js_chart_colors <- c("#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf")

app$chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

app$server$start_server()

## ----eval=FALSE---------------------------------------------------------------
# app$server$service()

## -----------------------------------------------------------------------------
app$chart_mgr$list_chart_types()

## ----eval=TRUE----------------------------------------------------------------
blocks_chart <- app$plot(tcga_colon_blocks, datasource_name="450k colon_blocks")

## ----eval=TRUE----------------------------------------------------------------
app$server$service()

## ----eval=TRUE----------------------------------------------------------------
# subset to those with length > 250Kbp
keep <- width(tcga_colon_blocks) > 250000

# get the data object for chart
ms_obj <- app$get_ms_object(blocks_chart)
app$update_measurements(ms_obj, tcga_colon_blocks[keep,])

## -----------------------------------------------------------------------------
app$chart_mgr$print_chart_type_info("BlocksTrack")

## ----eval=TRUE----------------------------------------------------------------
settings <- list(minBlockDistance=50)
colors <- c("#d15014", "#5e97eb", "#e81ccd")
blocks_chart <- app$plot(tcga_colon_blocks, datasource_name="450k colon_blocks", settings=settings, colors=colors)

## ----eval=TRUE----------------------------------------------------------------
# create a list of settings and colors to update the plot
settings <- list(minBlockDistance=100)
colors <- c("#5e97eb", "#d15014", "#e81ccd")
app$chart_mgr$set_chart_settings(blocks_chart, settings=settings, colors=colors)

## -----------------------------------------------------------------------------
# to list applied chart settings
app$chart_mgr$print_chart_info(blocks_chart)

## ----eval=TRUE----------------------------------------------------------------
app$chart_mgr$print_chart(blocks_chart, file_name="blocks_chart", file_type="pdf")

## ----eval=TRUE----------------------------------------------------------------
# add low-filter smoothed methylation estimates
means_track <- app$plot(tcga_colon_curves, datasource_name="450kMeth",type="bp",columns=c("cancerMean","normalMean"))

## ----eval=TRUE----------------------------------------------------------------
means_track$set(settings=list(step=1, interpolation="basis"))

## ----eval=TRUE----------------------------------------------------------------
diff_chart <- app$plot(tcga_colon_curves, datasource_name="450kMethDiff",type="bp",columns=c("smooth"),ylim=matrix(c(-.5,.5),nc=1))

## ----eval=TRUE----------------------------------------------------------------
app$chart_mgr$list_charts()
app$chart_mgr$rm_chart(means_track)
app$chart_mgr$list_charts()

## -----------------------------------------------------------------------------
keep <- pData(apColonData)$SubType!="adenoma"
apColonData <- apColonData[,keep]
status <- pData(apColonData)$Status
Indexes <- split(seq(along=status),status)

exprMat <- exprs(apColonData)
mns <- sapply(Indexes, function(ind) rowMeans(exprMat[,ind]))
mat <- cbind(colonM=mns[,"1"]-mns[,"0"], colonA=0.5*(mns[,"1"]+mns[,"0"]))

pd <- data.frame(stat=c("M","A"))
rownames(pd) <- colnames(mat)

maEset <- ExpressionSet(
  assayData=mat,
  phenoData=AnnotatedDataFrame(pd),
  featureData=featureData(apColonData),
  annotation=annotation(apColonData)
)
show(maEset)

## ----eval=TRUE----------------------------------------------------------------
eset_chart <- app$plot(maEset, datasource_name="MAPlot", columns=c("colonA","colonM"))

## -----------------------------------------------------------------------------
data(tcga_colon_expression)
show(tcga_colon_expression)

## ----eval=TRUE----------------------------------------------------------------
ref_sample <- 2 ^ rowMeans(log2(assay(tcga_colon_expression) + 1))
scaled <- (assay(tcga_colon_expression) + 1) / ref_sample
scaleFactor <- Biobase::rowMedians(t(scaled))
assay_normalized <- sweep(assay(tcga_colon_expression), 2, scaleFactor, "/")
assay(tcga_colon_expression) <- assay_normalized

## ----eval=TRUE----------------------------------------------------------------
status <- colData(tcga_colon_expression)$sample_type
index <- split(seq(along = status), status)
logCounts <- log2(assay(tcga_colon_expression) + 1)
means <- sapply(index, function(ind) rowMeans(logCounts[, ind]))
mat <- cbind(cancer = means[, "Primary Tumor"], normal = means[, "Solid Tissue Normal"])

## ----eval=TRUE----------------------------------------------------------------
sumexp <- SummarizedExperiment(mat, rowRanges=rowRanges(tcga_colon_expression))
se_chart <- app$plot(sumexp, datasource_name="Mean by Sample Type", columns=c("normal", "cancer"))

## ----eval=FALSE, echo=TRUE----------------------------------------------------
# app$load_remote_measurements()
# remote_measurements <- app$data_mgr$get_remote_measurements()

## ----eval=FALSE, echo=TRUE----------------------------------------------------
# measurementList <- lapply(remote_measurements, function(m) {
#   if(m@name %in% c("colon normal", "lung normal", "breast normal", "colon tumor", "lung tumor", "breast tumor") && m@datasourceId == "gene_expression_barcode_subtype") {
#     m
#   }
# })
# 
# measurements <- Filter(Negate(is.null), measurementList)

## ----eval=FALSE, echo=TRUE----------------------------------------------------
# app$chart_mgr$visualize("HeatmapPlot", measurements = measurements)

## ----eval=TRUE----------------------------------------------------------------
app$navigate("chr11", 110000000, 120000000)

## ----eval=TRUE, warning=FALSE-------------------------------------------------
foldChange <- mat[,"cancer"]-mat[,"normal"]
ind <- order(foldChange,decreasing=TRUE)

# bounding 1Mb around each exon
slideshowRegions <- trim(rowRanges(sumexp)[ind] + 1000000L)
app$slideshow(slideshowRegions, n=5)

## ----eval=TRUE----------------------------------------------------------------
app$print_workspace(file_name="workspace", file_type="pdf")

## ----eval=TRUE----------------------------------------------------------------
app$save(file="app.rda", include_data=TRUE)

## ----eval=TRUE----------------------------------------------------------------
app <- restartEpiviz(file="app.rda", open_browser=TRUE)

## -----------------------------------------------------------------------------
app$stop_app()

## ----session-info, cache=FALSE------------------------------------------------
sessionInfo()

.register_all_the_epiviz_things <- function(app) {
  # register actions requested from epiviz app
  app$server$register_action("getMeasurements", function(request_data) {
    app$data_mgr$get_measurements()
  })
  
  app$server$register_action("getRows", function(request_data) {
    app$data_mgr$get_rows(request_data$seqName,
      request_data$start,
      request_data$end,
      request_data$metadata, 
      request_data$datasource)
  })
  
  app$server$register_action("getValues", function(request_data) {
    app$data_mgr$get_values(request_data$seqName, 
      request_data$start, 
      request_data$end,
      request_data$datasource, 
      request_data$measurement)
  })
  
  app$server$register_action("getSeqInfos", function(request_data) {
    app$data_mgr$get_seqinfo()
  })
    
  app$server$register_action("registerChartTypes", function(request_data) {
    app$chart_mgr$.register_available_chart_types(request_data$data)
  })
  
  app$server$register_action("setChartSettings", function(request_data) {
    app$chart_mgr$.update_chart_settings(request_data)
  })
  
  ## TODO: register action 'search'
}

#' Start epiviz app and create \code{\link{EpivizApp}} object to manage connection.
#' 
#' @param host (character) use a host for the epiviz app other than the cbcb.umd.edu hosts.
#' @param http_port (integer) port at host serving the epiviz app.
#' @param path (character) path at host where epiviz app is located.
#' @param use_devel (logical) use the devel epiviz application server (http://epiviz-dev.cbcb.umd.edu).
#' @param chr (character) chromosome to browse to on app startup.
#' @param start (integer) start location to browse to on app startup.
#' @param end (integer) end location to browse to on app startup.
#' @param debug (logical) start epiviz app in debug mode.
#' @param workspace (character) a workspace id to load in the epiviz app on startup.
#' @param scripts (character) URLs for JavaScript plugin scripts to be imported when epiviz is loaded (see \url{http://epiviz.cbcb.umd.edu/help} for details).
#' @param gists (character) Ids for github gists (\url{http://gist.github.com}) containing JavaScript plugin scripts to
#'  be imported when epiviz is loaded (see \url{http://epiviz.cbcb.umd.edu/help} for details).
#' @param use_cookie (logical) use cookies within the epiviz app.
#' @param register_function (function) function used to register actions and charts on the epiviz app.
#' @param open_browser (logical) browse to the epiviz URL before exiting function.
#' @param server (EpivizServer) if not \code{NULL} use this object as underlying WebSocket and HTTP server
#' @param browser_fun (function) function used to browse to URL (\code{browseURL} by default)
#' @param ws_host (character) host address to use for websocket connection ("localhost" by default)
#' @param ... additional parameters passed to \code{\link[epivizrServer]{createServer}}.
#' 
#' @return An object of class \code{\link{EpivizApp}}
#' 
#' @examples
#' # see package vignete for example usage
#' app <- startEpiviz(non_interactive=TRUE, open_browser=TRUE)
#' app$stop_app()
#' 
#' @export
startEpiviz <- function(host=NULL, http_port=NULL, path=NULL, use_devel=FALSE, 
                        chr="chr11", start=99800000, end=103383180, 
                        debug=FALSE, workspace=NULL, scripts=NULL, gists=NULL, use_cookie=TRUE,
                        register_function=.register_all_the_epiviz_things,
                        open_browser=TRUE, server=NULL, browser_fun=utils::browseURL, 
                        ws_host="localhost", ...) {

  if(is.null(server) || !is(server, "EpivizServer") ) {
    server <- epivizrServer::createServer(...)
  }
  
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  url_parms <- list(host=host,
    http_port=http_port,
    path=path,
    ws_port=server$.port,
    use_devel=use_devel,
    debug=debug,
    chr=chr,
    start=start,
    end=end,
    workspace=workspace,
    scripts=scripts,
    gists=gists,
    use_cookie=use_cookie,
    ws_host=ws_host)
  
  app <- EpivizApp$new(.url_parms=url_parms,
                       .browser_fun=browser_fun,
                       server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  if (app$server$.verbose) {
    cat("Starting Epivizr!\n")
  }
  
  register_function(app)
  
  if (!app$server$is_interactive()) {
    return(app)
  }
  
  if (app$server$.verbose) {
    cat("Initializing session manager...\n")
  }
  tryCatch({
    if (app$server$.verbose) {
      cat("Opening connections...\n")
    }
    
    if (open_browser) {
      app$.open_browser()
    }

    if (app$server$.verbose) {
      cat("Done starting Epivizr!\n")
    }
    app
  }, error=function(e) {
    app$stop_app()
    stop("Error starting Epiviz: ", e)
  }, interrupt=function(e) {NULL})  
}

context("start epiviz")

test_that("startEpiviz creates a proper object", {
  app <- startEpiviz(non_interactive=TRUE)
  expect_is(app, "EpivizApp")
  
  expect_is(app$server, "EpivizServer")
  expect_is(app$chart_mgr, "EpivizChartMgr")
  expect_is(app$data_mgr, "EpivizDataMgr")
  
  expect_true(app$server$is_closed())
})

.startMGR=function(openBrowser=FALSE, verbose=TRUE, ...) {
  if (openBrowser) {
    tryCatch(startEpiviz(localURL=getOption("epivizrTestURL"), 
    					debug=getOption("epivizrTestDebug"), 
                                        daemonized=getOption("epivizrTestDaemonized"),
                         standalone=getOption("epivizrTestStandalone"),
                                        port=getOption("epivizrTestPort"),
    					openBrowser=TRUE, 
    					verbose=verbose, ...), interrupt=function(e) invisible())
  } else {
    startEpiviz(localURL=getOption("epivizrTestURL"),
    			debug=getOption("epivizrTestDebug"),
                        daemonized=getOption("epivizrTestDaemonized"),
                standalone=getOption("epivizrTestStandalone"),
                        port=getOption("epivizrTestPort"),
    			openBrowser=FALSE, 
    			verbose=verbose, ...)
  }
}

wait_until <- function(condition, timeout=3) {
  condition <- substitute(condition)
  ptm <- proc.time()
  while (!eval(condition, parent.frame()) && (proc.time() - ptm < timeout)["elapsed"]) {
    Sys.sleep(0.001)
  }
  expect_true(eval(condition, parent.frame()))
}

#' Class encapsulating a chart in epiviz app
#' 
#' @import methods
#' @include EpivizChartMgr-class.R
EpivizChart <- setRefClass("EpivizChart",
	fields=list(
		.measurements = "list",
    .datasource = "ANY",
    .datasourceGroup = "ANY",
	  .datasourceOriginName = "character",
		.mgr_id = "character",
		.app_id = "character",
		.mgr = "EpivizChartMgr",
		.type ="character",
		.settings = "list",
		.colors = "character" ),
	methods=list(
		set_id = function(id) { 
		  "Set chart's id assigned by chart manager."
		  .self$.mgr_id <- id 
		},
		get_id = function() { 
		  "Get chart's id assigned by chart manager"
		  .self$.mgr_id 
		},
	  get_source_name = function() { 
	    "Get chart's id assigned by chart manager"
	    .self$.datasourceOriginName
	  },
		set_app_id = function(id) { 
		  "Set chart's id assigned by epiviz app."
		  .self$.app_id <- id 
		},
		get_app_id = function(id) { 
		  "Get chart's id assigned by epiviz app."
		  .self$.app_id 
		},
		is_connected = function() { 
		  "Returns \\code{TRUE} if chart is connected to a chart on epiviz app."
		  isTRUE(length(.self$.app_id) > 0) 
		},
		print_info = function() {
		  "Print settings and color currently used in chart object."
		  cat("Chart settings for chart id ", .self$.mgr_id, ":\n")
		  print(.settings_as_df(.self$.settings))
		  
		  cat("Colors: ")
		  cat(paste0(.self$.colors, collapse=", "), "\n")
		  invisible()
		},
		.update = function(settings=NULL, colors=NULL) {
		  if (!is.null(settings)) {
		    settings <- .self$set_settings(settings)
		  }
		  
		  if (!is.null(colors)) {
		    .self$set_colors(colors)
		  }
		  
		  invisible()
		},
		set = function(settings=NULL, colors=NULL) {
		  "Set settings and colors used in chart.
		  \\describe{
		    \\item{settings}{List of settings to apply.}
        \\item{colors}{Character vector of HEX colors to use in chart.}
		  }"
		  if (!is.null(settings)) {
  		  settings <- .self$set_settings(settings)
		  }
		  
		  if (!is.null(colors)) {
  		  .self$set_colors(colors)
		  }
		  
		  if (.self$is_connected() && !(is.null(settings) && is.null(colors))) {
		    callback <- function(response) {
		      cat("settings successfully applied to ", .self$.mgr_id)
		    }
		    
		    request_data <- list(action = "setChartSettings",
		                         chartId = .self$.app_id,
		                         settings = settings,
		                         colorMap = .self$get_colors())
		    .self$.mgr$.server$send_request(request_data, callback)
		  }
		  invisible()
		},
		.filter_settings = function(settings=NULL) {
		  if (is.null(settings)) {
		    return(settings)
		  }
		  
		  js_chart_settings <- .self$.settings
		  is_setting_valid <- names(settings) %in% sapply(js_chart_settings, function(x) x$id)
		  invalid_settings <- names(settings)[!is_setting_valid]
		  
		  # list unrecognized settings
		  if(sum(!is_setting_valid) > 0) {
		    warning("unrecognized settings - (", paste0(invalid_settings, collapse=","), ") discarded! \n")
		    cat("Please use the method: list_chart_settings for available settings! \n")
		  }
		  
		  if (sum(is_setting_valid) == 0) {
		    return(NULL)
		  } 
		  
		  out_settings <- settings[is_setting_valid]
		  out_settings
		},
		set_settings = function(settings) {
		  "Set custom settings for the chart. Returns subset of valid settings.
		  \\describe{
		    \\item{settings}{List of settings to apply.}
		  }"
		  if (!is.null(settings)) {
		    settings <- .self$.filter_settings(settings)
		    for (id in names(settings)) {
		      pos <- which(sapply(.self$.settings, function(x) x$id) == id)
		      .self$.settings[[pos]]$defaultValue <- settings[[id]]
		    }
		  }
		  settings
		},
		get_settings = function() {
		  "Get custom settings for the chart."
		  .self$.settings
		},
		set_colors = function(colors) {
		  "Set custom colors for the chart."
		  .self$.colors <- colors
		},
		get_colors = function() {
		  "Get color palette applied to the chart."
		  .self$.colors
    },
		get_measurements = function() {
  	  "Get measurements for the chart."
  	  .self$.measurements
    }
	)
)

#' Print information about EpivizChart
#' @param object an \code{\link{EpivizChart}} object
#' @return Nothing, this function is called for its side-effects
#' @export
setMethod("show", signature(object="EpivizChart"),
  function(object) {
    cat("EpivizChart object ", object$get_id(), ":\n")
    cat("type: ", object$.type, "\n")
    cat("measurements:\n")
    num_measurements <- length(object$.measurements)
    num_to_show <- pmin(10, num_measurements)
    
    for (i in seq_len(num_to_show)) {
      ms <- object$.measurements[[i]]
      cat(paste0("[", i, "] "))
      callGeneric(ms)
      cat("\n")
    }
    
    if (num_to_show < num_measurements) {
      num_left <- num_measurements - num_to_show
      cat(paste0("<", num_left, " more>"), "\n")
    }
})

context("plot methods")

test_that("plot block works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  ms_obj <- data_mgr$add_measurements(gr, "ms1", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()
  
  chart_mgr$register_chart_type("BlocksTrack", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$plot(ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.BlocksTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("plot bp works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
                               ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
                               score1=rnorm(length(seq(1,100,by=25))),
                               score2=rnorm(length(seq(1,100,by=25))))
  
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  
  chart_mgr$register_chart_type("LineTrack", "epiviz.plugins.charts.LineTrack")
  chart_obj <- chart_mgr$plot(ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms_obj$get_measurements())
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.LineTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("plot feature works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  sset <- make_test_SE()

  ms_obj <- data_mgr$add_measurements(sset, "ms1", send_request=FALSE, columns=c("A","B"), assay="counts2")
  ms_id <- ms_obj$get_id()

  chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot")    
  chart_obj <- chart_mgr$plot(ms_obj)
  chart_id <- chart_obj$get_id()
  ms <- ms_obj$get_measurements()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.ScatterPlot")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
})

test_that("plot gene track works", {
  skip_if_not_installed("bumphunter")
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- make_test_gene_info()
  
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="gene_info", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  
  chart_mgr$register_chart_type("GenesTrack", "epiviz.plugins.charts.GenesTrack")    
  chart_obj <- chart_mgr$plot(ms_obj)
  chart_id <- chart_obj$get_id()
  ms <- ms_obj$get_measurements()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.GenesTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
})

context("disconnected add charts")

test_that("adding a block chart works using visualize with just measurement", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  ms_obj <- data_mgr$add_measurements(gr, "ms1", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()

  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", measurements=ms)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.BlocksTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("adding a block chart works using visualize with just datasource", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  ms_obj <- data_mgr$add_measurements(gr, "ms1", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.BlocksTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())  
})

test_that("adding a block chart works using visualize with both arguments", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  ms_obj <- data_mgr$add_measurements(gr, "ms1", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()

  chart_obj <- chart_mgr$visualize("BlockChart", measurements=ms, datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.BlocksTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("adding a line chart works using visualize with just measurement", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
    ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
    score1=rnorm(length(seq(1,100,by=25))),
    score2=rnorm(length(seq(1,100,by=25))))

  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()[2]
  
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_obj <- chart_mgr$visualize("LineChart", measurements=ms)
  chart_id <- chart_obj$get_id()

  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.LineTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("adding a line chart works using visualize with just datasource", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
                               ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
                               score1=rnorm(length(seq(1,100,by=25))),
                               score2=rnorm(length(seq(1,100,by=25))))
  
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()[2]
  
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_obj <- chart_mgr$visualize("LineChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms_obj$get_measurements())
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.LineTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

test_that("adding a line chart works using visualize with both arguments", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
                               ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
                               score1=rnorm(length(seq(1,100,by=25))),
                               score2=rnorm(length(seq(1,100,by=25))))
  
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()[2]
  
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_obj <- chart_mgr$visualize("LineChart", measurements=ms, datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.LineTrack")
  expect_true(exists(chart_id, env=chart_mgr$.chart_list))
  expect_equal(chart_obj$get_app_id(), character())
})

make_test_eset <- function() {
  require(hgu133plus2.db)
  set.seed(1)
  nprobeids <- 1000
  nsamples <- 6
  expr <- matrix(rnorm(nprobeids*nsamples), nr = nprobeids)
  pd <- data.frame(a = 1:nsamples, b = 10*(1:nsamples))
  rownames(pd) <- paste0("SAMP_", 1:nsamples)
  rownames(expr) <- head(keys(hgu133plus2.db, keytype="PROBEID"), nprobeids)
  colnames(expr) <- rownames(pd)

  ExpressionSet(assayData = expr, 
                phenoData = AnnotatedDataFrame(pd),
                annotation = "hgu133plus2")
}

make_test_SE <- function() {
	nranges <- 200
	nsamples <- 6
	counts1 <- matrix(runif(nranges*nsamples, 1, 1e4), nranges)
	counts2 <- matrix(runif(nranges*nsamples, 1, 1e2), nranges)

	rowRanges<- sort(GenomicRanges::GRanges(rep(c("chr1","chr2"), c(50,150)),
		IRanges::IRanges(floor(runif(200,1e5,1e6)), width = 100),
		strand = sample(c("+","-"), 200, TRUE),
    probeid = paste0("sid_", 1:200)))
	colData = S4Vectors::DataFrame(Treatment = rep(c("ChIP","Input"), 3),
	                    row.names=LETTERS[1:6])
	SummarizedExperiment::SummarizedExperiment(assays = S4Vectors::SimpleList(counts1 = counts1,
	                                         counts2 = counts2),
	                     rowRanges = rowRanges,
	                     colData = colData)
}

if (is.null(getOption("epivizrTestSendRequest")))
  options(epivizrTestSendRequest=TRUE)

if (is.null(getOption("epivizrTestDaemonized")))
  options(epivizrTestDaemonized=TRUE)

if (is.null(getOption("epivizrTestURL")))
  options(epivizrTestURL="http://epiviz.cbcb.umd.edu/test_socket.php")

if (is.null(getOption("epivizrTestDebug")))
  options(epivizrTestDebug=TRUE)

if (is.null(getOption("epivizrTestProxy")))
  options(epivizrTestProxy=TRUE)

options(epivizrTesting=TRUE)

.canPhantomTest <- function() {
  if(Sys.which("phantomjs") == "") { return(FALSE) }
  if(!getOption("epivizrCanDaemonize")) { return(FALSE) }
  TRUE
}

remDr <- NULL
pJS <- NULL

.startRemoteDriver <- function() {
  if(!require(RSelenium)) {
    stop("can't run this test here")
  }
  
  if(!.canPhantomTest()) {
    stop("can't do headless testing here")
  }
  
  pJS <<- phantom()
  Sys.sleep(2)
  
  remDr <<- remoteDriver(browserName = 'phantomjs')
  res <- remDr$open()
  invisible()
}

.navigateRemoteDriver <- function(port=7123L, path="", host="127.0.0.1") {
  url <- sprintf("http://%s:%d/%s", host, port, path)
  parallel::mcparallel(remDr$navigate(url), detached=TRUE)
  Sys.sleep(2)
}

.stopPhantomJS <- function() {
  pJS$stop()
}

context("connected app data update")

test_that("connected data update through app works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=1))
  gr2 <- GenomicRanges::GRanges(seqnames="chr12", ranges=IRanges::IRanges(start=1:1000,width=10))
  
  chart_mgr$register_chart_type("BlocksTrack")
  chart_obj <- app$plot(gr, datasource_name="ms1")
  chart_id <- chart_obj$get_id()
  wait_until(!server$has_request_waiting())
  Sys.sleep(1)
  
  ms_obj <- app$get_ms_object(chart_obj)
  app$update_measurements(ms_obj, gr2)
  wait_until(!server$has_request_waiting())
  Sys.sleep(1)

  outEl <- remDr$findElement(using="id", "clear_cache_output")
  res <- outEl$getElementText()[[1]]
  expect_equal(res, paste(ms_obj$get_id(), "cache cleared."))
  
  outputEl <- remDr$findElement(using="id", "redraw_output")
  out_text <- outputEl$getElementText()[[1]]
  expect_equal(out_text, "redraw called")
})

context("browser commands")

test_that("navigate works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  app$navigate(chr="chr10", start=2000, end=10000)
  wait_until(!app$server$has_request_waiting())
  
  outputEl <- remDr$findElement(using="id", "navigate_output")
  obs_location <- outputEl$getElementText()[[1]]
  expect_equal(obs_location, "chr10:2000-10000")
})

test_that("slideshow works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  app <- EpivizApp$new(server=server,
    data_mgr=data_mgr,
    chart_mgr=chart_mgr)
  
  granges <- GenomicRanges::GRanges("chr10", 
    IRanges::IRanges(start=(1:10)*1000, width=10000))
  
  callback <- function(chr, start, end) {
    wait_until(!app$server$has_request_waiting())
    outputEl <- remDr$findElement(using="id", "navigate_output")
    obs_location <- outputEl$getElementText()[[1]]
    expect_equal(obs_location, sprintf("%s:%d-%d", chr, start, end))
  }
  app$slideshow(granges, n=4, .callback=callback)
})

context("connected app plot methods")

test_that("plot feature works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  se <- make_test_SE()

  chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot")    
  chart_obj <- app$plot(se, datasource_name="ms1", columns=c("A","B"), assay="counts2")
  chart_id <- chart_obj$get_id()
  wait_until(!server$has_request_waiting())
  Sys.sleep(2)
  
  expect_true(chart_obj$is_connected())
  
  ms_obj <- app$get_ms_object(chart_id) 
  ms_id <- ms_obj$get_id()
  ms <- ms_obj$get_measurements()

  outputEl <- remDr$findElement(using="id", "add_chart_output")
  ms_list <- outputEl$getElementText()[[1]]
  exp_list <- paste0(sprintf("%s:%s", ms_id, c("A","B")), collapse=",")
  exp_list <- paste0("epiviz.plugins.charts.ScatterPlot:", chart_obj$.app_id, "[", exp_list, "]")
  expect_equal(ms_list, exp_list)
})

context("connected start epiviz")

test_that("startEpiviz creates a proper object", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment.")
  }
  
  app <- startEpiviz(open_browser=FALSE,
                     port=7123L,
                     static_site_path=".",
                     daemonized=TRUE,
                     verbose=TRUE)
  
  if (!app$server$is_daemonized()) {
    skip("This test can only run for daemonized servers.")
  }
  
  .startRemoteDriver()
  on.exit(.stopPhantomJS())
  
  app$server$start_server()
  on.exit(app$server$stop_server(), add=TRUE)

  .navigateRemoteDriver(port=app$server$.port)
  wait_until(app$server$is_socket_connected())
  
  title <- remDr$getTitle()[[1]]
  expect_equal(title, "EpivizServer Test Page")
  
  expect_false(app$server$is_closed())
  remDr$close()
})

context("object creation")

test_that("EpivizChartMgr creates a proper object", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment.")
  }
  
  server <- epivizrServer::createServer(port=7123L,
                                        static_site_path=".",
                                        daemonized=TRUE,
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test can only run for daemonized servers.")
  }
  
  .startRemoteDriver()
  on.exit(.stopPhantomJS())
  
  server$start_server()
  on.exit(server$stop_server(), add=TRUE)
  
  mgr <- EpivizChartMgr$new(server)
  .navigateRemoteDriver(port=server$.port)
  wait_until(mgr$.server$is_socket_connected())
  
  title <- remDr$getTitle()[[1]]
  expect_equal(title, "EpivizServer Test Page")
  remDr$close()
  expect_false(mgr$is_server_closed())
})

test_that("EpivizApp works as expected", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment.")
  }
  
  server <- epivizrServer::createServer(port=7123L,
                                        static_site_path=".",
                                        daemonized=TRUE,
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test can only run for daemonized servers.")
  }
  
  .startRemoteDriver()
  on.exit(.stopPhantomJS())
  
  server$start_server()
  on.exit(server$stop_server(), add=TRUE)
  
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(app$server$is_socket_connected())
  
  title <- remDr$getTitle()[[1]]
  expect_equal(title, "EpivizServer Test Page")
  
  expect_false(app$server$is_closed())
  remDr$close()
})

#' Class providing chart manager for epiviz app
#' 
#' @import methods
#' @importClassesFrom epivizrServer EpivizServer
EpivizChartMgr <- setRefClass("EpivizChartMgr",
  fields=list(
    .chart_list = "environment",
    .chart_id_counter = "integer",
    .server = "EpivizServer",
    .chart_type_map = "list"
  ),
  methods=list(
    initialize = function(server=epivizrServer::createServer(), ...) {
      .self$.server <- server
      .self$.chart_list <- new.env(parent=emptyenv())
      .self$.chart_id_counter <- 0L
    },
    num_charts= function() { 
      "Return the number of charts currently loaded through manager."
      length(ls(.self$.chart_list)) 
    },
    show = function() {
      "Print manager information to screen."
      cat("Epiviz chart manager object:\n")
      cat("Server: ")
      .self$.server$show(); cat("\n")
#     st <- .self$list_charts()
#     if(length(st)>0) {
#        cat("Charts:\n")
#        print(st); cat("\n")
#      }      
    },
    is_server_closed = function() { 
      "Returns \\code{TRUE} if underlying server is closed.
      See \\code{is_closed} method in class \\code{\\link{EpivizServer}}."
      is.null(.self$.server) || .self$.server$is_closed()
    },
    .get_chart_object = function(chart_object_or_id) {
      chart_obj <- NULL
      if (is.character(chart_object_or_id)) {
        id <- chart_object_or_id
        if (!exists(id, envir=.self$.chart_list, inherits=FALSE)) {
          stop("chart with id ", id, " not found")                  
        }
        chart_obj <- .self$.chart_list[[id]]
      } else {
        chart_obj <- chart_object_or_id
      }
      chart_obj
    },
    .get_chart_from_app_id = function(chart_app_id) {
      chart_obj <- NULL
      c_ids <- ls(.self$.chart_list)
      if (length(c_ids) == 0) {
        return(NULL)
      }
      
      id <- NULL
      
      for (c_id in c_ids) {
        if(.self$.chart_list[[c_id]]$.app_id == chart_app_id) {
          id <- c_id
        }
      }
      
      if(is.null(id)) {
        stop("chart with app id ", chart_app_id, " not found")  
      }
      
      chart_obj <- .self$.chart_list[[id]]
      chart_obj  
    },
    add_chart = function(chart_object, send_request=TRUE) {
      "Add a chart to the chart manager.
       \\describe{
        \\item{chart_object}{an object of class \\code{\\link{EpivizChart}}}
        \\item{send_request}{send request to app through websocket}
      }"
      .self$.chart_id_counter <- .self$.chart_id_counter + 1L
      chart_id <- sprintf("epivizChart_%d", .self$.chart_id_counter)
      chart_object$set_id(chart_id)
      .self$.chart_list[[chart_id]] <- chart_object

      send_request <- !.self$is_server_closed() && isTRUE(send_request)      
      if (send_request) {
        callback <- function(response_data) {
          app_chart_id <- response_data$value$id
          chart_object$set_app_id(app_chart_id)
          cat("Chart ", chart_id, " added to browser and connected to id ", app_chart_id, "\n")
        }
        measurements <- NULL
        if (!is.null(chart_object$.measurements)) { 
          measurements = epivizrServer::json_writer(lapply(chart_object$.measurements, epivizrData::as.list)) 
        }
        
        request_data=list(action="addChart",
          type=chart_object$.type,
          measurements=measurements,
          datasource=chart_object$.datasource,
          datasourceGroup=chart_object$.datasourceGroup
        )
        .self$.server$send_request(request_data, callback)
      }
      invisible()
    },
    print_chart=function(chart_object_or_id, file_name=NULL, file_type=c("pdf","png")) {
      "Print specific chart to file.
       \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
          string indicating the chart's id assigned by chart manager.}
        \\item{file_name}{Name of file to print to.}
        \\item{file_type}{Type of file to print. One of \\code{pdf} or \\code{png}.}
       }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)
      
      if (!is(chart_object, "EpivizChart"))
        stop("'chartObj' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("chart ", chart_id, " not found")
      }
      
      if (chart_object$is_connected()) {
        callback <- function(response) {
          cat("chart ", chart_id, " is being saved\n")
        }
        
        request_data <- list(action = "printWorkspace",
                             chartId = chart_object$.app_id,
                             fileName = file_name,
                             fileType = file_type)
        .self$.server$send_request(request_data, callback)
      }
      invisible()
    },
    rm_chart = function(chart_object_or_id) {
      "Remove chart from chart manager.
       \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
          string indicating the chart's id assigned by chart manager}
       }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)

      if (!is(chart_object, "EpivizChart"))
        stop("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("object not found")
      }
      rm(list=chart_id, envir=.self$.chart_list)

      if (chart_object$is_connected()) {
        callback <- function(response) {
          cat("chart ", chart_id, " removed and disconnected\n")
        }
        
        request_data <- list(action = "removeChart",
          chartId = chart_object$.app_id)
        .self$.server$send_request(request_data, callback)
      }
      invisible()
    },
    rm_all_charts = function() {
      "Remove all charts loaded by chart manager."
      ids <- ls(.self$.chart_list)
      for (id in ids) {
          .self$rm_chart(id)
      }
      invisible()
    },
    list_charts = function() {
      "Return \\code{data.frame} describing charts loaded by chart manager"
      ids <- ls(.self$.chart_list)
      if (length(ids) == 0) {
        return(NULL)
      }
      
      type <- sapply(ids, function(x) .self$.chart_list[[x]]$.type)
      ms <- sapply(ids,
                   function(x) {
                     tmp <- sapply(.self$.chart_list[[x]]$.measurements, function(y) paste0(y@datasourceId,":",y@name))
                     paste0(tmp, collapse=",")
                   })
      connected <- ifelse(sapply(ids, function(x) .self$.chart_list[[x]]$is_connected()), "*", "")
      out <- data.frame(id=ids,
                        type=type,
                        measurements=ms,
                        connected=connected,
                        stringsAsFactors=FALSE)
      rownames(out) <- NULL
      out
    },
    register_chart_type = function(chart_type, js_chart_type=paste0("epiviz.plugins.charts.", chart_type), 
                                   js_chart_settings=list(), js_chart_colors=character()) {
      "Register a chart type name to a JavaScript chart type in the epiviz app.
      \\describe{
        \\item{chart_type}{the name to use for chart type in R (e.g., 'BlocksTrack')}
        \\item{js_chart_type}{the full JavaScript class name of the corresponding chart type 
          (e.g. 'epiviz.plugins.charts.BlocksTrack'). If missing it is taken from the \\code{chart_type} argument}
        \\item{js_chart_settings}{custom settings that can be applied to this chart type in JS.}
        \\item{js_chart_colors}{default color palette applied to this chart type in JS.}
      }"
      .self$.chart_type_map[[chart_type]] <- list(js_chart_type=js_chart_type, js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)
    },
    print_chart_type_info = function(chart_type) {
      "Print settings and color information for a given chart type
      \\describe{
        \\item{chart_type}{the name for a chart type in R (e.g., 'BlocksTrack', 'StackedLineTrack')}
      }"
      cat("Settings for chart type ", chart_type, "\n")
      print(.self$list_chart_type_settings(chart_type))
      
      cat("Colors: ")
      cat(paste0(.self$list_chart_type_colors(chart_type), collapse=", "), "\n")
    },
    list_chart_type_settings = function(chart_type) {
      "List available settings for a specific chart type.
      \\describe{
        \\item{chart_type}{the name for a chart type in R (e.g., 'BlocksTrack', 'StackedLineTrack')}
      }"
      chart_settings <- .self$.chart_type_map[[chart_type]]$js_chart_settings
      .settings_as_df(chart_settings)
    },
    list_chart_type_colors = function(chart_type) {
      "List colors currently used in given chart type"
      chart_colors <- .self$.chart_type_map[[chart_type]]$js_chart_colors
      chart_colors
    },
    list_chart_types = function(col_width=80) {
      "List charts types registered in epivizr with their default settings and colors. 
       Returns a \\code{data.frame} listing available chart types and a summary of the 
       settings that can be modified.
      
      \\describe{
        \\item{col_width}{Maximum length of settings list displayed.}
      }"
      types <- ls(.self$.chart_type_map)
      js_classes <- sapply(types, function(chart_type) {
        .self$.chart_type_map[[chart_type]]$js_chart_type  
      })
      
      num_settings <- sapply(types, function(chart_type) {
        length(.self$.chart_type_map[[chart_type]]$js_chart_settings)
      })
      
      settings_prefix <- sapply(types, function(chart_type) {
        setting_ids <- sapply(.self$.chart_type_map[[chart_type]]$js_chart_settings, function(x) x$id)
        out <- paste0(setting_ids, collapse=",")
        if (nchar(out) > col_width) {
          out <- paste0(substr(out, 1, col_width), "...")
        }
        out
      })
      num_colors <- sapply(types, function(chart_type) {
        length(.self$.chart_type_map[[chart_type]]$js_chart_colors)
      })
      out <- data.frame(type=types, js_class=js_classes, num_settings=num_settings, 
                 settings=settings_prefix, num_colors=num_colors)
      rownames(out) <- NULL
      out
    },
    .register_available_chart_types = function(request_data) {
      for (x in request_data) {
        .self$register_chart_type(gsub("epiviz.plugins.charts.", "", x$chartName, fixed = TRUE), 
                                  js_chart_type=x$chartName, 
                                  js_chart_settings=x$customSettings,
                                  js_chart_colors=x$colorMap)
      }
      invisible(NULL)
    },
    .update_chart_settings = function(request_data) {
      
      chart_app_id <- request_data$chartId
      chart_object <- .self$.get_chart_from_app_id(chart_app_id)
      
      if (!is(chart_object, "EpivizChart"))
        warning("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        warning("object ", chart_id, " not found")
      }
      
      chart_object$.update(settings=request_data$settings, colors=request_data$colorMap)
      invisible()
      
    },
    set_chart_settings = function(chart_object_or_id, settings=NULL, colors=NULL) {
      "Apply custom chart settings or colors to a chart object.
      
      \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
          string indicating the chart's id assigned by chart manager}
        \\item{settings}{a list of settings to apply to the chart}
        \\item{colors}{a list of (HEX code) colors to use in the chart}
      }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)
      
      if (!is(chart_object, "EpivizChart"))
        stop("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("object ", chart_id, " not found")
      }
      
      chart_object$set(settings=settings, colors=colors)
      invisible()
      
    },
    get_chart_settings = function(chart_object_or_id) {
      "List chart settings for a specific chart object.
      \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
        string indicating the chart's id assigned by chart manager}
      }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)
      
      if (!is(chart_object, "EpivizChart"))
        stop("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("object not found")
      }
      
      chart_object$.get_chart_settings_df()
    },
    get_chart_colors = function(chart_object_or_id) {
      "List colors used in a specific chart object.
      \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
        string indicating the chart's id assigned by chart manager}
      }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)
      
      if (!is(chart_object, "EpivizChart"))
        stop("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("object not found")
      }
      
      chart_object$get_colors()
    },
    print_chart_info = function(chart_object_or_id) {
      "Print settings and colors used in a specific chart object.
      \\describe{
        \\item{chart_object_or_id}{An object of class \\code{\\link{EpivizChart}} or a 
        string indicating the chart's id assigned by chart manager}
      }"
      chart_object <- .self$.get_chart_object(chart_object_or_id)
      
      if (!is(chart_object, "EpivizChart"))
        stop("'chart_object' must be an 'EpivizChart' object")
      
      chart_id <- chart_object$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("object not found")
      }
      
      chart_object$print_info()
      invisible()
    },
    visualize = function(chart_type, measurements = NULL, datasource = NULL, 
                         settings=NULL, colors=NULL, send_request=TRUE, ...) {
      "Visualize data use the given chart type. One of arguments \\code{measurements} or \\code{datasource} must be non-\\code{NULL}. If \\code{measurements}
      is \\code{NULL}, the \\code{get_measurements} method in class \\code{\\link{EpivizData}}
      is used to decide which measurements are used in the chart
      
      \\describe{
        \\item{chart_type}{a chart type registered using the \\code{register_chart_type} method}
        \\item{measurements}{a list of \\code{\\link{EpivizMeasurement}} objects
          describing measurements to include in the chart}
        \\item{datasource}{an object of class \\code{\\link{EpivizData}}, all available
          measurements from datasource are used as appropriate}
      }"
      
      js_chart_type <- .self$.chart_type_map[[chart_type]]$js_chart_type
      js_chart_settings <- .self$.chart_type_map[[chart_type]]$js_chart_settings
      js_chart_colors <- .self$.chart_type_map[[chart_type]]$js_chart_colors
      
      if (is.null(js_chart_type)) {
        stop("Can't visualize ", chart_type, ", it is not registered")
      }

      # check if no measurements given
      if (is.null(measurements)) {
        # check if datasource is given
        if (!is.null(datasource)) {
          measurements <- datasource$get_measurements()
        } else {
          stop("Either 'measurements' or 'datasource' must be non-NULL")
        }
      }
      
      datasource_id <- measurements[[1]]@datasourceId
      datasource_name <- measurements[[1]]@datasourceName
      
      chart_obj <- EpivizChart$new(
        .measurements=measurements,
        .datasource=datasource_id,
        .datasourceGroup=datasource_id,
        .datasourceOriginName=datasource_name,
        .mgr=.self,
        .type=js_chart_type,
        .settings=js_chart_settings,
        .colors=js_chart_colors)
      
      .self$add_chart(chart_obj, send_request=send_request, ...)
      .self$.server$wait_to_clear_requests()
      
      # if (!chart_obj$is_connected() && !.self$is_server_closed()) {
      #   stop("Error adding chart to epiviz\n")
      # }
      
      chart_id <- chart_obj$get_id()
      if(!exists(chart_id, envir=.self$.chart_list, inherits=FALSE)) {
        stop("Chart object not found \n")
      }
      
      if (!is.null(settings) || !is.null(colors)) {
        .self$set_chart_settings(chart_obj, settings=settings, colors=colors)
      }
      chart_obj
    },
    revisualize = function(chart_type, chart, ...){
        "Revisualize uses data the given chart and replots it in the given chart type. The argument \\code{chart} must be non-\\code{NULL}.
        \\describe{
        \\item{chart_type}{a chart type registered using the \\code{register_chart_type} method}
        \\item{chart}{a chart that includes measurements to be used in a new chart}
        }"
        if (!is.null(chart)){
          measurements <- chart$get_measurements()
        } 
        else {
          stop("Either 'chart' must be non-NULL")
        }
    
        .self$visualize(chart_type = chart_type, measurements = measurements, ...)
    },
    plot = function(measurement_object, settings=NULL, colors=NULL, send_request=TRUE) {
      "Visualize data in an \\code{\\link{EpivizData}} object using its default chart type.
      The method \\code{get_default_chart_type} in class \\code{\\link{EpivizData}} is used
      to determine which chart type is used.

      \\describe{
        \\item{measurement_object}{an object of class \\code{\\link{EpivizData}}}
        \\item{settings}{list of settings to use in chart (uses default chart settings if NULL)}
        \\item{colors}{character vector of HEX colors to use in chart (uses default chart colors if NULL)}
      }"
      if (!is(measurement_object, "EpivizData")) {
        stop("'measurement_object' must be of class 'EpivizData'")
      }
      chart_type <- measurement_object$get_default_chart_type()
      .self$visualize(chart_type, datasource=measurement_object, settings=settings, colors=colors, send_request=send_request)
    },
    .redraw = function(send_request = TRUE) {
      send_request <- !.self$is_server_closed() && isTRUE(send_request)      
      if (send_request) {
        callback <- function(response_data) {
          if (.self$.server$.verbose) {
            cat("charts redraw\n")            
          }
        }
        request_data <- list(action="redraw")
        .self$.server$send_request(request_data, callback)
      }
      invisible()
    },
    .redraw_chart = function(chart, send_request = TRUE){
      send_request <- !.self$is_server_closed() && isTRUE(send_request)      
      
      if (send_request) {
        callback <- function(response_data) {
          app_chart_id <- response_data$value$id
          
          chart$set_app_id(app_chart_id)
          
          settings <- NULL
          if(!is.null(chart$get_settings())) {
            settings <- chart$get_settings()
          }
          
          colors <- NULL
          if(!is.null(chart$get_colors())) {
            colors <- chart$get_colors()
          }
          
          chart$set(settings=settings, colors=colors)
          
          if (.self$.server$.verbose) {
            cat("Chart ", chart$get_id(), "re-drawn\n")            
          }
        }
        
        measurements <- NULL
        if (!is.null(chart$.measurements)) { 
          measurements = epivizrServer::json_writer(lapply(chart$.measurements, epivizrData::as.list)) 
        }
        
        request_data <- list(action="addChart",
          type=chart$.type,
          measurements=measurements,
          datasource=chart$.datasource,
          datasourceGroup=chart$.datasourceGroup
        )
        .self$.server$send_request(request_data, callback)
      }
      
      invisible()
    },
    redraw_charts = function(send_request = TRUE){
      chart_ids <- ls(envir=.self$.chart_list)
      
      for (id in chart_ids){
        chart_obj <- .self$.get_chart_object(id)
        .self$.redraw_chart(chart_obj, send_request)
        .self$.server$wait_to_clear_requests()
      }
      invisible()
    }
  )
)                              

context("object creation")

test_that("EpivizChartMgr creates a proper object", {
  server <- epivizrServer::createServer()
  mgr <- EpivizChartMgr$new(server)
  
  expect_is(mgr, "EpivizChartMgr")
  
  expect_is(mgr$.chart_list, "environment")
  expect_equal(mgr$num_charts(), 0)
  expect_equal(mgr$.chart_id_counter, 0)
  expect_equal(length(mgr$.chart_type_map), 0)
  
  expect_is(mgr$.server, "EpivizServer")
  expect_true(mgr$is_server_closed())
})

test_that("server opening works as expected", {
  server <- epivizrServer::createServer(try_ports=TRUE)
  mgr <- EpivizChartMgr$new(server)
  expect_true(mgr$is_server_closed())
  
  server$start_server()
  on.exit(server$stop_server())
  expect_false(mgr$is_server_closed())
})

test_that("register_chartType works as expected", {
  server <- epivizrServer::createServer()
  mgr <- EpivizChartMgr$new(server)
  mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")  
  expect_equal(length(mgr$.chart_type_map), 1)
  expect_equal(mgr$.chart_type_map$BlockChart$js_chart_type, "epiviz.plugins.charts.BlocksTrack")
})

test_that("EpivizApp works as expected", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  expect_is(app, "EpivizApp")
  expect_is(app$server, "EpivizServer")

  expect_is(app$chart_mgr, "EpivizChartMgr")
  expect_equal(app$server, app$chart_mgr$.server)
  
  expect_is(app$data_mgr, "EpivizDataMgr")
  expect_equal(app$server, app$data_mgr$.server)
  
  expect_equal(app$data_mgr$num_datasources(), 0)
  expect_equal(app$chart_mgr$num_charts(), 0)
})

context("disconnected manage charts")

test_that("rm_chart works usign chart object", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
    ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
    score1=rnorm(length(seq(1,100,by=25))),
    score2=rnorm(length(seq(1,100,by=25))))

  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  chart_mgr$rm_chart(chart_obj)
  expect_equal(chart_mgr$num_charts(), 0)
  expect_false(exists(chart_id, env=chart_mgr$.chart_list, inherits=FALSE))
})

test_that("rm_chart works usign chart id", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
                               ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
                               score1=rnorm(length(seq(1,100,by=25))),
                               score2=rnorm(length(seq(1,100,by=25))))
  
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms_id <- ms_obj$get_id()
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  
  chart_mgr$rm_chart(chart_id)
  
  expect_equal(chart_mgr$num_charts(), 0)
  expect_false(exists(chart_id, env=chart_mgr$.chart_list, inherits=FALSE))
})

test_that("rm_all_charts works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr2", ranges=IRanges::IRanges(start=2:20, width=100))
  gr3 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- data_mgr$add_measurements(gr1, "dev1", send_request=FALSE); devId1 <- dev1$get_id()
  dev2 <- data_mgr$add_measurements(gr2, "dev2", send_request=FALSE); devId2 <- dev2$get_id()
  dev3 <- data_mgr$add_measurements(gr3, "dev3", send_request=FALSE, type="bp"); devId3 <- dev3$get_id()
  dev4 <- data_mgr$add_measurements(se, "dev4", send_request=send_request, columns=c("A", "B")); devId4 <- dev4$get_id()

  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_mgr$register_chart_type("ScatterChart", "epiviz.plugins.charts.ScatterChart")
  
  chart1 <- chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- chart_mgr$visualize("BlockChart", datasource=dev2)
  chart3 <- chart_mgr$visualize("LineChart", datasource=dev3)
  chart4 <- chart_mgr$visualize("ScatterChart", datasource=dev4)

  expect_equal(chart_mgr$num_charts(), 4)    
  chart_mgr$rm_all_charts()
  expect_equal(chart_mgr$num_charts(), 0)
})

test_that("list_charts works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr2", ranges=IRanges::IRanges(start=2:20, width=100))
  gr3 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- data_mgr$add_measurements(gr1, "dev1", send_request=FALSE); devId1 <- dev1$get_id()
  dev2 <- data_mgr$add_measurements(gr2, "dev2", send_request=FALSE); devId2 <- dev2$get_id()
  dev3 <- data_mgr$add_measurements(gr3, "dev3", send_request=FALSE, type="bp"); devId3 <- dev3$get_id()
  dev4 <- data_mgr$add_measurements(se, "dev4", send_request=send_request, columns=c("A", "B")); devId4 <- dev4$get_id()
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot")
  
  chart1 <- chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- chart_mgr$visualize("BlockChart", datasource=dev2)
  chart3 <- chart_mgr$visualize("LineChart", datasource=dev3)
  chart4 <- chart_mgr$visualize("ScatterPlot", datasource=dev4)
  charts_list <- chart_mgr$list_charts()
    
  ids <- c(chart1$get_id(), chart2$get_id(), chart3$get_id(), chart4$get_id())
  type <- c("epiviz.plugins.charts.BlocksTrack",
            "epiviz.plugins.charts.BlocksTrack",
            "epiviz.plugins.charts.LineTrack",
            "epiviz.plugins.charts.ScatterPlot")
    ms <- c(paste0(dev1$get_id(),":",dev1$get_name()),
            paste0(dev2$get_id(),":",dev2$get_name()), 
            paste0(dev3$get_id(), ":score"),
            paste0(dev4$get_id(), ":", c("A","B"), collapse=","))
    connected <- rep("", 4)
    expected_df <- data.frame(id=ids,
                              type=type,
                              measurements=ms,
                              connected=connected,
                              stringsAsFactors=FALSE)
    expect_equal(charts_list, expected_df)
})

test_that("checking that revisualize works", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
         ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
         score1=rnorm(length(seq(1,100,by=25))),
         score2=rnorm(length(seq(1,100,by=25))))
    
  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp", send_request=FALSE)
  ms <- ms_obj$get_measurements()[2]
  
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
    
  chart1 <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
    
  chart_obj <- chart_mgr$visualize("LineChart", measurements=ms)
  chart_obj_rev <- chart_mgr$revisualize(chart_type = "BlockChart", chart=chart_obj)
    
  expect_is(chart_obj, "EpivizChart")
  expect_equal(chart_obj$.measurements, ms)
  expect_equal(chart_obj_rev$.measurements, ms)
  expect_equal(chart_obj$.type, "epiviz.plugins.charts.LineTrack")
  expect_equal(chart_obj_rev$.type, "epiviz.plugins.charts.BlocksTrack")
})

context("connected manage charts")

test_that("redraw works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  chart_mgr$.redraw()
  outputEl <- remDr$findElement(using="id", "redraw_output")
  out_text <- outputEl$getElementText()[[1]]
  expect_equal(out_text, "redraw called")
})

test_that("rm_chart works using chart object", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  gr <- GenomicRanges::GRanges(seqnames="chr1", 
    ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), 
    score1=rnorm(length(seq(1,100,by=25))),
    score2=rnorm(length(seq(1,100,by=25))))

  ms_obj <- data_mgr$add_measurements(gr, "ms1", type="bp")
  ms_id <- ms_obj$get_id()
  wait_until(!server$has_request_waiting())
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_obj <- chart_mgr$visualize("BlockChart", datasource=ms_obj)
  chart_id <- chart_obj$get_id()
  wait_until(!server$has_request_waiting())
  Sys.sleep(2)

  chart_mgr$rm_chart(chart_obj)
  wait_until(!server$has_request_waiting())
  Sys.sleep(2)
  
  outputEl <- remDr$findElement(using="id", "add_chart_output")
  ms_list <- outputEl$getElementText()[[1]]
  expect_equal(ms_list, "")
})

test_that("rm_all_charts works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())

  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr2", ranges=IRanges::IRanges(start=2:20, width=100))
  gr3 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- data_mgr$add_measurements(gr1, "dev1"); devId1 <- dev1$get_id()
  dev2 <- data_mgr$add_measurements(gr2, "dev2"); devId2 <- dev2$get_id()
  dev3 <- data_mgr$add_measurements(gr3, "dev3", type="bp"); devId3 <- dev3$get_id()
  dev4 <- data_mgr$add_measurements(se, "dev4", columns=c("A", "B")); devId4 <- dev4$get_id()
  wait_until(!server$has_request_waiting())
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_mgr$register_chart_type("ScatterChart", "epiviz.plugins.charts.ScatterChart")
  
  chart1 <- chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- chart_mgr$visualize("BlockChart", datasource=dev2)
  chart3 <- chart_mgr$visualize("LineChart", datasource=dev3)
  chart4 <- chart_mgr$visualize("ScatterChart", datasource=dev4)
  wait_until(!server$has_request_waiting())

  expect_true(chart1$is_connected())
  expect_true(chart2$is_connected())
  expect_true(chart3$is_connected())
  expect_true(chart4$is_connected())

  outputEl <- remDr$findElement(using="id", "add_chart_output")
  ms_list <- outputEl$getElementText()[[1]]
  
  exp_list <- paste0("epiviz.plugins.charts.BlocksTrack:", chart1$.app_id, "[", devId1, ":", devId1, "],")
  exp_list <- paste0(exp_list,
                     "epiviz.plugins.charts.BlocksTrack:", chart2$.app_id, "[", devId2, ":", devId2, "],")
  exp_list <- paste0(exp_list,
                     "epiviz.plugins.charts.LineTrack:", chart3$.app_id, "[", devId3, ":score],")
  
  tmp <- paste0(sprintf("%s:%s", devId4, c("A","B")), collapse=",")
  tmp <- paste0("epiviz.plugins.charts.ScatterChart:", chart4$.app_id, "[", tmp, "]")
  exp_list <- paste0(exp_list, tmp)
  expect_equal(ms_list, exp_list)
  
  chart_mgr$rm_all_charts()
  wait_until(!server$has_request_waiting())
  Sys.sleep(2)
  
  outputEl <- remDr$findElement(using="id", "add_chart_output")
  ms_list <- outputEl$getElementText()[[1]]
  expect_equal(ms_list, "")
})

test_that("list_charts works", {
  skip_on_os("windows")
  skip_if_not_installed("RSelenium")
  
  if (!.canPhantomTest()) {
    skip("This test can't be run in this environment")
  }
  
  server <- epivizrServer::createServer(port=7123L, 
                                        static_site_path=".",
                                        daemonized=TRUE, 
                                        verbose=TRUE)
  if (!server$is_daemonized()) {
    skip("This test only works for daemonized servers")
  }
  
  .startRemoteDriver()
  on.exit({cat("stopping remDr\n"); .stopPhantomJS()})
  
  server$start_server()
  on.exit({cat("stopping server\n"); server$stop_server()}, add=TRUE)
  
  chart_mgr <- EpivizChartMgr$new(server)
  data_mgr <- epivizrData::createMgr(server)
  
  .navigateRemoteDriver(port=server$.port)
  wait_until(server$is_socket_connected())
  
  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr2", ranges=IRanges::IRanges(start=2:20, width=100))
  gr3 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- data_mgr$add_measurements(gr1, "dev1"); devId1 <- dev1$get_id()
  dev2 <- data_mgr$add_measurements(gr2, "dev2"); devId2 <- dev2$get_id()
  dev3 <- data_mgr$add_measurements(gr3, "dev3", type="bp"); devId3 <- dev3$get_id()
  dev4 <- data_mgr$add_measurements(se, "dev4", columns=c("A", "B")); devId4 <- dev4$get_id()
  wait_until(!server$has_request_waiting())
  
  chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot")
  
  chart1 <- chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- chart_mgr$visualize("BlockChart", datasource=dev2)
  chart3 <- chart_mgr$visualize("LineChart", datasource=dev3)
  chart4 <- chart_mgr$visualize("ScatterPlot", datasource=dev4)
  wait_until(!server$has_request_waiting())
  
  charts_list <- chart_mgr$list_charts()
    
  ids <- c(chart1$get_id(), chart2$get_id(), chart3$get_id(), chart4$get_id())
  type <- c("epiviz.plugins.charts.BlocksTrack",
            "epiviz.plugins.charts.BlocksTrack",
            "epiviz.plugins.charts.LineTrack",
            "epiviz.plugins.charts.ScatterPlot")
    ms <- c(paste0(dev1$get_id(),":",dev1$get_name()),
            paste0(dev2$get_id(),":",dev2$get_name()), 
            paste0(dev3$get_id(), ":score"),
            paste0(dev4$get_id(), ":", c("A","B"), collapse=","))
    connected <- rep("*", 4)
    expected_df <- data.frame(id=ids,
                              type=type,
                              measurements=ms,
                              connected=connected,
                              stringsAsFactors=FALSE)
    expect_equal(charts_list, expected_df)
})

context("restart epiviz")

test_that("restartEpiviz restarts connection and workspace from file", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- app$data_mgr$add_measurements(gr1, "dev1", send_request=FALSE)
  dev2 <- app$data_mgr$add_measurements(gr2, "dev2", send_request=FALSE, type="bp")
  dev3 <- app$data_mgr$add_measurements(se, "dev3", send_request=FALSE, columns=c("A", "B"))
  
  app$chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  app$chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  app$chart_mgr$register_chart_type("ScatterChart", "epiviz.plugins.charts.ScatterChart")
  
  chart1 <- app$chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- app$chart_mgr$visualize("LineChart", datasource=dev2)
  chart3 <- app$chart_mgr$visualize("ScatterChart", datasource=dev3)
  
  file_name <- tempfile(fileext=".rda")
  
  #expect_false(app$server$is_closed())
  expect_false(file.exists(file_name))
  
  app$save(file=file_name, include_data=TRUE)
  app$stop_app()
  
  expect_true(file.exists(file_name))
  
  app2 <- restartEpiviz(file_name, open_browser=FALSE)
  
  expect_is(app2, "EpivizApp")
  expect_is(app2$server, "EpivizServer")
  expect_is(app2$chart_mgr, "EpivizChartMgr")
  expect_is(app2$data_mgr, "EpivizDataMgr")

  expect_equal(app2$chart_mgr$num_charts(), 3)  
  
  #app$stop_app()
  #file.remove(file_name)
})

test_that("restartEpiviz restarts connection and workspace from environment", {
  server <- epivizrServer::createServer()
  data_mgr <- epivizrData::createMgr(server)
  chart_mgr <- EpivizChartMgr$new(server)
  app <- EpivizApp$new(server=server,
                       data_mgr=data_mgr,
                       chart_mgr=chart_mgr)
  
  
  gr1 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=1:10, width=100))
  gr2 <- GenomicRanges::GRanges(seqnames="chr1", ranges=IRanges::IRanges(start=seq(1,100,by=25), width=1), score=rnorm(length(seq(1,100,by=25))))
  se <- make_test_SE()
  
  dev1 <- app$data_mgr$add_measurements(gr1, "dev1", send_request=FALSE)
  dev2 <- app$data_mgr$add_measurements(gr2, "dev2", send_request=FALSE, type="bp")
  dev3 <- app$data_mgr$add_measurements(se, "dev3", send_request=FALSE, columns=c("A", "B"))
  
  app$chart_mgr$register_chart_type("BlockChart", "epiviz.plugins.charts.BlocksTrack")
  app$chart_mgr$register_chart_type("LineChart", "epiviz.plugins.charts.LineTrack")
  app$chart_mgr$register_chart_type("ScatterChart", "epiviz.plugins.charts.ScatterChart")
  
  chart1 <- app$chart_mgr$visualize("BlockChart", datasource=dev1)
  chart2 <- app$chart_mgr$visualize("LineChart", datasource=dev2)
  chart3 <- app$chart_mgr$visualize("ScatterChart", datasource=dev3)
  
  file_name <- tempfile(fileext=".rda")
  
  #expect_false(app$server$is_closed())
  expect_false(file.exists(file_name))
  
  app$save(file=file_name,include_data=FALSE)
  app$stop_app()
  
  expect_true(file.exists(file_name))
  #expect_true(app$server$is_closed())
  
  app2 <- restartEpiviz(file_name, open_browser=FALSE)
  
  #expect_false(app$server$is_closed())
  expect_is(app2, "EpivizApp")
  expect_is(app2$server, "EpivizServer")
  expect_is(app2$chart_mgr, "EpivizChartMgr")
  expect_is(app2$data_mgr, "EpivizDataMgr")
  
  expect_equal(app2$chart_mgr$num_charts(), 3)  
  
  chart_ids <- ls(envir=app$chart_mgr$.chart_list)
  chart_source_names <- lapply(chart_ids, function(id){
    chart_obj <- app$chart_mgr$.get_chart_object(id)
    chart_source <- chart_obj$get_source_name()
  })
  
  datasource_names <- ls(app$data_mgr$.ms_list)
  data_mgr_origin_names <- lapply(datasource_names, function(name) {
    ms_obj <- app$data_mgr$.get_ms_object(name);
    ms_obj$get_source_name()
  })
  
  for (chart_source_name in chart_source_names){
    expect_true(chart_source_name %in% data_mgr_origin_names)
  }

  #app$stop_app()
  #file.remove(file_name)
})

wait_until <- function(condition, timeout=3) {
  condition <- substitute(condition)
  ptm <- proc.time()
  while (!eval(condition, parent.frame()) && (proc.time() - ptm < timeout)["elapsed"]) {
    Sys.sleep(0.001)
  }
  expect_true(eval(condition, parent.frame()))
}

---
title: "Introduction to `epivizr`: interactive visualization for genomic data"
author: "Héctor Corrada Bravo"
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Introduction to epivizr}
  %\VignetteEncoding{UTF-8}
---

[`Epiviz`](http://epiviz.cbcb.umd.edu) is an interactive visualization tool for functional genomics data. It supports genome navigation like other genome browsers, but allows multiple visualizations of data within genomic regions using scatterplots, heatmaps and other user-supplied visualizations. It also includes data from the [Gene Expression Barcode project](http://barcode.luhs.org/) for transcriptome visualization. It has a flexible plugin framework so users can add [d3](http://d3js.org/) visualizations. You can find more information about Epiviz at [http://epiviz.cbcb.umd.edu/help](http://epiviz.cbcb.umd.edu/help) and see a video tour [here](http://youtu.be/099c4wUxozA).

<iframe width="480" height="360" src="http://www.youtube.com/embed/099c4wUxozA" frameborder="1" allowfullscreen></iframe>

The `r Biocpkg("epivizr")` package implements two-way communication between the `R/Bioconductor` computational genomics environment and `Epiviz`. Objects in an `R` session can be displayed as tracks or plots on Epiviz. Epivizr uses Websockets for communication between the browser Javascript client and the R environment, the same technology underlying the popular [Shiny](http://www.rstudio.com/shiny/) system for authoring interactive web-based reports in R.

# Preliminaries: the data

In this vignette we will look at colon cancer methylation data from the TCGA project and expression data from the gene expression barcode project. The `r Biocpkg("epivizrData")` package contains human chromosome 11 methylation data from the Illumina 450kHumanMethylation beadarray processed with the `r Biocpkg("minfi")` package. We use expression data from the `r Biocpkg("antiProfilesData")` bioconductor package.

```{r, eval=TRUE, echo=TRUE, results='hide', warning=FALSE, error=FALSE, message=FALSE}
library(epivizr)
library(antiProfilesData)
library(SummarizedExperiment)
```

```{r}
data(tcga_colon_blocks)
data(tcga_colon_curves)
data(apColonData)
```

The `tcga_colon_blocks` object is a `GRanges` object containing chromosome 11 regions of hypo or hyper methylation in colon cancer identified using the `blockFinder` function in the `r Biocpkg("minfi")` package. 

```{r}
show(tcga_colon_blocks)
```

The columns `value` and `p.value` can be used to determine which of these regions, or blocks, are interesting by looking at a volcano plot for instance.

```{r, fig.width=4, fig.height=4, fig.align='center'}
plot(tcga_colon_blocks$value, -log10(tcga_colon_blocks$p.value), main="Volcano plot", xlab="Avg. methylation difference", ylab="-log10 p-value",xlim=c(-.5,.5))
```

The `tcga_colon_curves` object is another `GRanges` object which contains the basepair resolution methylation data used to define these regions.

```{r}
show(tcga_colon_curves)
```

This basepair resolution data includes mean methylation levels for normal and cancer and a smoothed estimate of methylation difference. This smoothed difference estimate is used to define regions in the `tcga_colon_blocks` object.

Finally, the `apColonData` object is an `ExpressionSet` containing gene expression data for colon normal and tumor samples for genes within regions of methylation loss identified [this paper](http://www.nature.com/ng/journal/v43/n8/full/ng.865.html). Our goal in this vignette is to visualize this data as we browse the genome.

# Using epivizr

## The epivizr app

The connection to `Epiviz` is managed through a session manager object of class `EpivizApp`. We can create this object and open `Epiviz` using the `startEpiviz` function.

```{r, eval=FALSE, echo=TRUE}
app <- startEpiviz(workspace="qyOTB6vVnff", gists="2caf8e891201130c7daa")
```

```{r, eval=TRUE, echo=FALSE}
app <- startEpiviz(host="http://localhost", http_port=8989, debug=TRUE, open_browser=FALSE, non_interactive=TRUE, try_ports=TRUE)


# register BlockTrack
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 25, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 23, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 20, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 10, label = "Right margin", possibleValues = NULL), list(id = "minBlockDistance", type = "number", defaultValue = 5, label = "Minimum block distance", possibleValues = NULL))

js_chart_colors = c("#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf")

app$chart_mgr$register_chart_type("BlocksTrack", "epiviz.plugins.charts.BlocksTrack", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

# register LineTrack
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 25, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 23, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 20, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 10, label = "Right margin", possibleValues = NULL), list(id = "measurementGroupsAggregator", type = "categorical", defaultValue = "mean-stdev", label = "Aggregator for measurement groups", possibleValues = c("mean-stdev", "quartiles", "count", "min", "max", "sum")), list(id = "step", type = "number", defaultValue = 50, label = "Step", possibleValues = NULL), list(id = "showPoints", type = "boolean", defaultValue = FALSE, label = "Show points", possibleValues = NULL), list(id = "showLines", type = "boolean", defaultValue = TRUE, label = "Show lines", possibleValues = NULL), list(id = "showErrorBars", type = "boolean", defaultValue = TRUE, label = "Show error bars", possibleValues = NULL), list(id = "pointRadius", type = "number", defaultValue = 1, label = "Point radius", possibleValues = NULL), list(id = "lineThickness", type = "number", defaultValue = 1, label = "Line thickness", possibleValues = NULL), list(id = "yMin", type = "number", defaultValue = "default", label = "Min Y", possibleValues = NULL), list(id = "yMax", type = "number", defaultValue = "default", label = "Max Y", possibleValues = NULL), list(id = "interpolation", type = "categorical", defaultValue = "linear", label = "Interpolation", possibleValues = c("linear", "step-before", "step-after", "basis", "basis-open", "basis-closed", "bundle", "cardinal", "cardinal-open", "monotone")))

js_chart_colors <- c("#1859a9", "#ed2d2e", "#008c47", "#010101", "#f37d22", "#662c91", "#a11d20", "#b33893")

app$chart_mgr$register_chart_type("LineTrack", "epiviz.plugins.charts.LineTrack", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

# register ScatterPlot
js_chart_settings <- list(list(id = "title", type = "string", defaultValue = "", label = "Title", possibleValues = NULL), list(id = "marginTop", type = "number", defaultValue = 15, label = "Top margin", possibleValues = NULL), list(id = "marginBottom", type = "number", defaultValue = 50, label = "Bottom margin", possibleValues = NULL), list(id = "marginLeft", type = "number", defaultValue = 50, label = "Left margin", possibleValues = NULL), list(id = "marginRight", type = "number", defaultValue = 15, label = "Right margin", possibleValues = NULL), list(id = "measurementGroupsAggregator", type = "categorical", defaultValue = "mean-stdev", label = "Aggregator for measurement groups", possibleValues = c("mean-stdev", "quartiles", "count", "min", "max", "sum")), list(id = "circleRadiusRatio", type = "number", defaultValue = 0.015, label = "Circle radius ratio", possibleValues = NULL), list(id = "xMin", type = "number", defaultValue = "default", label = "Min X", possibleValues = NULL), list(id = "xMax", type = "number", defaultValue = "default", label = "Max X", possibleValues = NULL), list(id = "yMin", type = "number", defaultValue = "default", label = "Min Y", possibleValues = NULL), list(id = "yMax", type = "number", defaultValue = "default", label = "Max Y", possibleValues = NULL))

js_chart_colors <- c("#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf")

app$chart_mgr$register_chart_type("ScatterPlot", "epiviz.plugins.charts.ScatterPlot", js_chart_settings=js_chart_settings, js_chart_colors=js_chart_colors)

app$server$start_server()
```
This opens a websocket connection between the interactive `R` session and the browser client. This will allow us to visualize data stored in the `Epiviz` server along with data in the interactive `R` session.

----

*Windows users:* In Windows platforms we need to use the `service` function to let the interactive `R` session connect to the `epiviz` web app and serve data requests. We then escape (using `ctl-c` or `esc` depending on your environment) to continue with the interactive `R` session. This is required anytime you want `epivizr` to serve data to the web app, for example, when interacting with the UI. (We are actively developing support for non-blocking sessions in Windows platforms).

```{r, eval=FALSE}
app$server$service()
```

----

## Listing available chart types

Once the browser is open and is connected to an active epivizr session, the epivizr session registers available chart types supported in the epiviz JS app. To list available chart types we use method `list_chart_types`. In this vignette, we only show three chart types available for use in the epiviz JS app. The production epiviz JS app has a larger number of chart types available. Chart types can also be added dynamically as described in the epiviz JS documentation: [http://epiviz.cbcb.umd.edu/help](http://epiviz.cbcb.umd.edu/help). Chart types that are added dynamically are listed and usable within an `epivizr` session.

```{r}
app$chart_mgr$list_chart_types()
```

Chart type settings, e.g., line widths, colors, margins etc. can be modified dynamically. Settings available for each chart type are briefly listed in this call. See below for further detail on customizing charts through settings and colors.

# Adding charts

## Adding block region tracks

Once the browser is open we can visualize the `tcga_colon_blocks` object containing blocks of methylation modifications in colon cancer.
We use the `plot` method to do so. 

```{r,eval=TRUE}
blocks_chart <- app$plot(tcga_colon_blocks, datasource_name="450k colon_blocks")
```

----

*Windows users:* We need the `service` function to let the interactive `R` session serve data requests from the browser client as you interact with the UI. 
Escape (using `ctl-c` or `esc` depending on your environment) to continue with the interactive `R` session.

```{r,eval=TRUE}
app$server$service()
```

----

You should now see that a new track is added to the `Epiviz` web app. You can think of this track as an interactive display device in `R`. As you navigate on the browser, data is requested from the `R` session through the websocket connection. Remember to escape to continue with your interactive `R` session if you are not running "non-blocking" mode. The `blocks_chart` object inherits from class `EpivizChart`, which we can use to  get information about the data being displayed and the chart used to display it.  Note that the "brushing" effect we implement in `Epiviz` works for `epivizr` tracks as well.

Now that we have interactive data connections to `Epiviz` we may want to iteratively compute and visualize our data. For example, we may want to only display methylation blocks inferred at a certain statistical significance level. In this case, we will filter by block size.

```{r, eval=TRUE}
# subset to those with length > 250Kbp
keep <- width(tcga_colon_blocks) > 250000

# get the data object for chart
ms_obj <- app$get_ms_object(blocks_chart)
app$update_measurements(ms_obj, tcga_colon_blocks[keep,])
```

Now, only this subset of blocks will be displayed in the already existing track.

## Modifying chart settings and colors

To modify default chart colors or settings, we need to know what settings can be applied to the chart. Again, as these are defined dynamically in the epiviz JS app we use a method, `print_chart_type_info` on the `EpivizChartMgr` class to list settings that can be applied to specific chart type. For example, to list chart settings available for a `BlocksTrack` chart we use the following:

```{r}
app$chart_mgr$print_chart_type_info("BlocksTrack")
```

There are two ways to set settings and colors to a chart: when the chart is initially created using the `plot` method, or after the
chart is created using the `set` method in class `EpivizChart`. We will illustrate both ways of doing this:

If using the `plot` method, use the `list_chart_settings` method as above to list settings that can be applied to a chart type. 
For example, for a `BlocksTrack` chart, we can set `minBlockDistance` as a setting for the plot function which controls how close genomic
regions can be before they are merged into a single rectangle in the chart. We can also change colors used in the chart this way.
  
```{r, eval=TRUE}
settings <- list(minBlockDistance=50)
colors <- c("#d15014", "#5e97eb", "#e81ccd")
blocks_chart <- app$plot(tcga_colon_blocks, datasource_name="450k colon_blocks", settings=settings, colors=colors)
```

This will create a second blocks track using a different color map.

On the other hand, if the `BlockChart` is already added to the epiviz JS application session, use the `set_chart_settings` method to update settings and colors. 

```{r, eval=TRUE}
# create a list of settings and colors to update the plot
settings <- list(minBlockDistance=100)
colors <- c("#5e97eb", "#d15014", "#e81ccd")
app$chart_mgr$set_chart_settings(blocks_chart, settings=settings, colors=colors)
```

This changes the color map for the second blocks track added. Use the `print_chart_info` method to list settings and colors currently used in the chart.

```{r}
# to list applied chart settings
app$chart_mgr$print_chart_info(blocks_chart)
```

Methods are also available directly on the `EpivizChart` objects. E.g., calls `blocks_chart$set(settings=settings, colors=colors)`
and `blocks_chart$print_info()` yield the same result.

## Printing charts

Charts can be printed as a pdf or png file through the epivizr session. To do so, use the `print_chart` method:

```{r, eval=TRUE}
app$chart_mgr$print_chart(blocks_chart, file_name="blocks_chart", file_type="pdf")
```

This will create a file named `blocks_chart.pdf` which will be downloaded through your web browser. It will be found in the default file download location for your web browser.

## Adding line plots along the genome

There are a number of different data types available to use through `epivizr`. You can see a list of R/BioC classes that are supported using `?register`. In the previous section, we used the `block` data type to register a `GenomicRanges` object. To visualize methylation data at base-pair resolution from the `tcga_colon_curves` `GenomicRanges` object, we will use the `bp` type.

```{r, eval=TRUE}
# add low-filter smoothed methylation estimates
means_track <- app$plot(tcga_colon_curves, datasource_name="450kMeth",type="bp",columns=c("cancerMean","normalMean"))
```

NOTE: You can adjust track settings to change how this new track looks like. For instance, to show all points in the window set the `step` parameter to 1, and to see a smooth interpolation of the data set the `interpolation` parameter to `basis`:

```{r, eval=TRUE}
means_track$set(settings=list(step=1, interpolation="basis"))
```

Notice that we added two lines in this plot, one for mean methylation in cancer and another for mean methylation in normal. The `columns` argument specifies which columns in `mcols(colon_curves)` will be displayed. 

We can also add a track containing the smooth methylation difference estimate used to define methylation blocks.

```{r, eval=TRUE}
diff_chart <- app$plot(tcga_colon_curves, datasource_name="450kMethDiff",type="bp",columns=c("smooth"),ylim=matrix(c(-.5,.5),nc=1))
```

We pass limits for the y axis in this case. To see other arguments supported, you can use the help framework in R `?"EpivizApp"`. As before, we can specify settings for this new track.

# Managing the app

We can use the app connection object to list charts we have added so far, or to remove charts.

```{r, eval=TRUE}
app$chart_mgr$list_charts()
app$chart_mgr$rm_chart(means_track)
app$chart_mgr$list_charts()
```

# Charts that are not aligned to genomic location

## Adding a scatterplot

Now we want to visualize the colon expression data in `apColonData` object as an MA plot in `Epiviz`. First, we add an `"MA"` assay to the `ExpressionSet`:

```{r}
keep <- pData(apColonData)$SubType!="adenoma"
apColonData <- apColonData[,keep]
status <- pData(apColonData)$Status
Indexes <- split(seq(along=status),status)

exprMat <- exprs(apColonData)
mns <- sapply(Indexes, function(ind) rowMeans(exprMat[,ind]))
mat <- cbind(colonM=mns[,"1"]-mns[,"0"], colonA=0.5*(mns[,"1"]+mns[,"0"]))

pd <- data.frame(stat=c("M","A"))
rownames(pd) <- colnames(mat)

maEset <- ExpressionSet(
  assayData=mat,
  phenoData=AnnotatedDataFrame(pd),
  featureData=featureData(apColonData),
  annotation=annotation(apColonData)
)
show(maEset)
```

`epivizr` will use the `annotation(maEset)` annotation to determine genomic locations using the `AnnotationDbi` package so that only probesets inside the current browser window are displayed. 

```{r, eval=TRUE}
eset_chart <- app$plot(maEset, datasource_name="MAPlot", columns=c("colonA","colonM"))
```

In this case, we specify which data is displayed in each axis of the scatter plot using the `columns` argument. The `assay` arguments indicates where data is obtained.

## The RangedSummarizedExperiment Object

`Epiviz` is also able to display plots of data in the form of a `RangedSummarizedExperiment` object. After loading the `tcga_colon_expression` dataset in the `epivizrData` package, we can see that this object contains information on 239322 exons in 40 samples.

```{r}
data(tcga_colon_expression)
show(tcga_colon_expression)
```

The `assay` slot holds a matrix of raw sequencing counts, so before we can plot a scatterplot showing expression, we must first normalize the count data. We use the geometric mean of each row as a reference sample to divide each column (sample) by, then use the median of each column as a scaling factor to divide each row (exon) by.

```{r, eval=TRUE}
ref_sample <- 2 ^ rowMeans(log2(assay(tcga_colon_expression) + 1))
scaled <- (assay(tcga_colon_expression) + 1) / ref_sample
scaleFactor <- Biobase::rowMedians(t(scaled))
assay_normalized <- sweep(assay(tcga_colon_expression), 2, scaleFactor, "/")
assay(tcga_colon_expression) <- assay_normalized
```

Now, using the expression data in the `assay` slot and the sample data in the `colData` slot, we can compute mean exon expression by sample type.

```{r, eval=TRUE}
status <- colData(tcga_colon_expression)$sample_type
index <- split(seq(along = status), status)
logCounts <- log2(assay(tcga_colon_expression) + 1)
means <- sapply(index, function(ind) rowMeans(logCounts[, ind]))
mat <- cbind(cancer = means[, "Primary Tumor"], normal = means[, "Solid Tissue Normal"])
```

Now, create a new `RangedSummarizedExperiment` object with the two column matrix, and all the information about the features of interest, in this case exons, are stored in the `rowRanges` slot to be queried by `Epiviz`.

```{r, eval=TRUE}
sumexp <- SummarizedExperiment(mat, rowRanges=rowRanges(tcga_colon_expression))
se_chart <- app$plot(sumexp, datasource_name="Mean by Sample Type", columns=c("normal", "cancer"))
```
Again, the `columns` argument specifies what data will be displayed along which axis.

# Visualizing data available from epiviz webserver

## Load remote measurements

Epiviz web server (http://epiviz.cbcb.umd.edu) currently hosts data sets from several sources including Gene Expression Barcode project. We provide a way to load these remotely hosted datasets and integrate/analyze with your current workflow and local data. For this, Lets first get the list of measurements available from the webserver 


```{r, eval=FALSE, echo=TRUE}
app$load_remote_measurements()
remote_measurements <- app$data_mgr$get_remote_measurements()
```

## Query measurements and add charts
`remote_measurements` is a list of `EpivizMeasurement` objects. We can query this list to choose the datasets we would like to load from the webserver. For the purpose of this vignette, lets find measurements to visualize data from gene expression barcode project for tumor and normal samples from lung, colon and breast tissues.

```{r, eval=FALSE, echo=TRUE}
measurementList <- lapply(remote_measurements, function(m) {
  if(m@name %in% c("colon normal", "lung normal", "breast normal", "colon tumor", "lung tumor", "breast tumor") && m@datasourceId == "gene_expression_barcode_subtype") {
    m
  }
})

measurements <- Filter(Negate(is.null), measurementList)
```

Now lets add a heatmap using the measurements we just selected. For this we use the `visualize` function from the `EpivizChartMgr` class.

```{r, eval=FALSE, echo=TRUE}
app$chart_mgr$visualize("HeatmapPlot", measurements = measurements)
```

Similarly other chart types registered with the current epivizr session can be used with the datasets from the webserver.

# More application interactions

## Slideshow

We can navigate to a location on the genome using the `navigate` method of the app object:

```{r, eval=TRUE}
app$navigate("chr11", 110000000, 120000000)
```

There is a convenience function to quickly navigate to a series of locations in succession.
We can use that to browse the genome along a ranked list of regions. Let's navigate to the
5 most up-regulated exons in the colon exon expression data.

```{r, eval=TRUE, warning=FALSE}
foldChange <- mat[,"cancer"]-mat[,"normal"]
ind <- order(foldChange,decreasing=TRUE)

# bounding 1Mb around each exon
slideshowRegions <- trim(rowRanges(sumexp)[ind] + 1000000L)
app$slideshow(slideshowRegions, n=5)
```

## Printing the epivizr workspace

To print the current epiviz workspace as a pdf or png, we use the `print_workspace` method:

```{r, eval=TRUE}
app$print_workspace(file_name="workspace", file_type="pdf")
```

This will create a file named `workspace.pdf` and will be downloaded through your web browser. It will be saved to the default file download location for your web browser.

## Saving the epivizr workspace

To save the current state of the epiviz app, and UI workspace, into an `rda` file, we use the `save` method:

```{r, eval=TRUE}
app$save(file="app.rda", include_data=TRUE)
```

This will create a file named `app.rda` that can be restarted for later use and analysis. For a smaller file size, you may choose whether to include or exclude the data when saving the workspace. In this case, expressions used to add data
to the app, through `add_measurements` or `plot` as shown above, will be stored
and re-evaluated when restarting the app.

## Restarting the epivizr workspace

After a workspace is saved using the `save` method shown above, we can replot it using the following:

```{r, eval=TRUE}
app <- restartEpiviz(file="app.rda", open_browser=TRUE)
```

This will recreate the workspace in your web browser and reconnect it with the R session. If the workspace you are restarting did not include its data when saving the file, you will need to load the data in your global environment before restarting epiviz. This will allow to reload the data used in the app.

## Closing the session

To close the connection to `Epiviz` and remove all tracks added during the interactive session, we use the `stop_app` function.

```{r}
app$stop_app()
```

# Standalone version and browsing arbitrary genomes

The `epivizrStandalone` all files required to run the web app UI locally. This feature
can be used to browse any genome of interest. See that packages vignette for more information.

# SessionInfo

```{r session-info, cache=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vignette_data.R
\docType{data}
\name{tcga_colon_expression}
\alias{tcga_colon_expression}
\title{Example exon-level RNAseq data from TCGA project for epivizr vignette.}
\format{
A \code{\link[SummarizedExperiment:RangedSummarizedExperiment]{SummarizedExperiment::RangedSummarizedExperiment}} object with 12,800 rows (exons) and 40 samples.
\describe{
\item{\code{assay(tcga_colon_expression)}}{exon-level count matrix}
\item{\code{colData(tcga_colon_expression)}}{a \code{DataFrame} containing sample information.
Normal/Tumor status is given in column \code{sample_type}}
}
}
\source{
TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
}
\usage{
data(tcga_colon_expression)
}
\value{
A \code{\link[SummarizedExperiment:RangedSummarizedExperiment]{SummarizedExperiment::RangedSummarizedExperiment}} object.
}
\description{
A \code{\link[SummarizedExperiment:RangedSummarizedExperiment]{SummarizedExperiment::RangedSummarizedExperiment}} object containing exon-level
counts from RNAseq data for colon tumor and normal tissue from the TCGA project.
Only exons in human chromosome 11 are included.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vignette_data.R
\docType{data}
\name{tcga_colon_curves}
\alias{tcga_colon_curves}
\title{Example methylation data (smoothed methylation levels) for epivizr vignette}
\format{
A \code{\link{GRanges}} object with 7135 ranges and \code{mcols}:

\describe{
\item{\code{id}}{probe cluster id}
\item{\code{type}}{probe cluster type}
\item{\code{blockgroup}}{probe cluster block group}
\item{\code{diff}}{raw methylation percentage difference between normal and tumor}
\item{\code{smooth}}{smooth methylation percentage difference between normal and tumor}
\item{\code{normalMean}}{mean methylation estimate for normal samples}
\item{\code{cancerMean}}{mean methylation estimate for cancer samples}
}
}
\source{
TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
}
\usage{
data(tcga_colon_curves)
}
\description{
Example results from methylation analysis of human chromosome 11 using the \code{\link[minfi:minfi-package]{minfi::minfi-package}} package
of TCGA 450k beadarray samples. This object contains probe cluster level methylation estimates from
\code{\link[minfi:blockFinder]{minfi::blockFinder()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vignette_data.R
\docType{data}
\name{tcga_colon_blocks}
\alias{tcga_colon_blocks}
\title{Example methylation data (blocks) for epivizr vignette.}
\format{
A \code{\link{GRanges}} object with 129 and \code{mcols}:

\describe{
\item{\code{value}}{average smooth methylation difference within block}
\item{\code{area}}{block area estimate (abs(value) * length)}
\item{\code{cluster}}{id of cluster blockgroup within which block occurs}
\item{\code{indexStart}}{index of first cluster in block}
\item{\code{indexEnd}}{index of last cluster in block}
\item{\code{L}}{number of clusters in block}
\item{\code{clusterL}}{number of probes in block}
\item{\code{p.value}}{permutation p.value based on difference conditioned on length}
\item{\code{fwer}}{family-wise error rate estimate based on difference conditioned on length}
\item{\code{p.valueArea}}{permutation p.value based on area}
\item{\code{fwerArea}}{family-wise error rate estimate based on area}
}
}
\source{
TCGA project: \url{https://tcga-data.nci.nih.gov/tcga/}
}
\usage{
data(tcga_colon_blocks)
}
\description{
Example results from methylation analysis of human chromosome 11 using the \code{\link[minfi:minfi-package]{minfi::minfi-package}} package
of TCGA 450k beadarray samples. This object contains large regions of methylation difference between tumor
and normal samples obtained from \code{\link[minfi:blockFinder]{minfi::blockFinder()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EpivizChart-class.R
\name{show,EpivizChart-method}
\alias{show,EpivizChart-method}
\title{Print information about EpivizChart}
\usage{
\S4method{show}{EpivizChart}(object)
}
\arguments{
\item{object}{an \code{\link{EpivizChart}} object}
}
\value{
Nothing, this function is called for its side-effects
}
\description{
Print information about EpivizChart
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/startEpiviz.R
\name{startEpiviz}
\alias{startEpiviz}
\title{Start epiviz app and create \code{\link{EpivizApp}} object to manage connection.}
\usage{
startEpiviz(
  host = NULL,
  http_port = NULL,
  path = NULL,
  use_devel = FALSE,
  chr = "chr11",
  start = 99800000,
  end = 103383180,
  debug = FALSE,
  workspace = NULL,
  scripts = NULL,
  gists = NULL,
  use_cookie = TRUE,
  register_function = .register_all_the_epiviz_things,
  open_browser = TRUE,
  server = NULL,
  browser_fun = utils::browseURL,
  ws_host = "localhost",
  ...
)
}
\arguments{
\item{host}{(character) use a host for the epiviz app other than the cbcb.umd.edu hosts.}

\item{http_port}{(integer) port at host serving the epiviz app.}

\item{path}{(character) path at host where epiviz app is located.}

\item{use_devel}{(logical) use the devel epiviz application server (http://epiviz-dev.cbcb.umd.edu).}

\item{chr}{(character) chromosome to browse to on app startup.}

\item{start}{(integer) start location to browse to on app startup.}

\item{end}{(integer) end location to browse to on app startup.}

\item{debug}{(logical) start epiviz app in debug mode.}

\item{workspace}{(character) a workspace id to load in the epiviz app on startup.}

\item{scripts}{(character) URLs for JavaScript plugin scripts to be imported when epiviz is loaded (see \url{http://epiviz.cbcb.umd.edu/help} for details).}

\item{gists}{(character) Ids for github gists (\url{http://gist.github.com}) containing JavaScript plugin scripts to
be imported when epiviz is loaded (see \url{http://epiviz.cbcb.umd.edu/help} for details).}

\item{use_cookie}{(logical) use cookies within the epiviz app.}

\item{register_function}{(function) function used to register actions and charts on the epiviz app.}

\item{open_browser}{(logical) browse to the epiviz URL before exiting function.}

\item{server}{(EpivizServer) if not \code{NULL} use this object as underlying WebSocket and HTTP server}

\item{browser_fun}{(function) function used to browse to URL (\code{browseURL} by default)}

\item{ws_host}{(character) host address to use for websocket connection ("localhost" by default)}

\item{...}{additional parameters passed to \code{\link[epivizrServer]{createServer}}.}
}
\value{
An object of class \code{\link{EpivizApp}}
}
\description{
Start epiviz app and create \code{\link{EpivizApp}} object to manage connection.
}
\examples{
# see package vignete for example usage
app <- startEpiviz(non_interactive=TRUE, open_browser=TRUE)
app$stop_app()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EpivizChartMgr-class.R
\docType{class}
\name{EpivizChartMgr-class}
\alias{EpivizChartMgr-class}
\alias{EpivizChartMgr}
\title{Class providing chart manager for epiviz app}
\description{
Class providing chart manager for epiviz app
}
\section{Methods}{

\describe{
\item{\code{add_chart(chart_object, send_request = TRUE)}}{Add a chart to the chart manager.
 \describe{
  \item{chart_object}{an object of class \code{\link{EpivizChart}}}
  \item{send_request}{send request to app through websocket}
}}

\item{\code{get_chart_colors(chart_object_or_id)}}{List colors used in a specific chart object.
\describe{
  \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
  string indicating the chart's id assigned by chart manager}
}}

\item{\code{get_chart_settings(chart_object_or_id)}}{List chart settings for a specific chart object.
\describe{
  \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
  string indicating the chart's id assigned by chart manager}
}}

\item{\code{is_server_closed()}}{Returns \code{TRUE} if underlying server is closed.
See \code{is_closed} method in class \code{\link{EpivizServer}}.}

\item{\code{list_chart_type_colors(chart_type)}}{List colors currently used in given chart type}

\item{\code{list_chart_type_settings(chart_type)}}{List available settings for a specific chart type.
\describe{
  \item{chart_type}{the name for a chart type in R (e.g., 'BlocksTrack', 'StackedLineTrack')}
}}

\item{\code{list_chart_types(col_width = 80)}}{List charts types registered in epivizr with their default settings and colors. 
 Returns a \code{data.frame} listing available chart types and a summary of the 
 settings that can be modified.

\describe{
  \item{col_width}{Maximum length of settings list displayed.}
}}

\item{\code{list_charts()}}{Return \code{data.frame} describing charts loaded by chart manager}

\item{\code{num_charts()}}{Return the number of charts currently loaded through manager.}

\item{\code{plot(measurement_object, settings = NULL, colors = NULL, send_request = TRUE)}}{Visualize data in an \code{\link{EpivizData}} object using its default chart type.
      The method \code{get_default_chart_type} in class \code{\link{EpivizData}} is used
      to determine which chart type is used.

      \describe{
        \item{measurement_object}{an object of class \code{\link{EpivizData}}}
        \item{settings}{list of settings to use in chart (uses default chart settings if NULL)}
        \item{colors}{character vector of HEX colors to use in chart (uses default chart colors if NULL)}
      }}

\item{\code{print_chart(chart_object_or_id, file_name = NULL, file_type = c("pdf", "png"))}}{Print specific chart to file.
\describe{
 \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
   string indicating the chart's id assigned by chart manager.}
 \item{file_name}{Name of file to print to.}
 \item{file_type}{Type of file to print. One of \code{pdf} or \code{png}.}
}}

\item{\code{print_chart_info(chart_object_or_id)}}{Print settings and colors used in a specific chart object.
\describe{
  \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
  string indicating the chart's id assigned by chart manager}
}}

\item{\code{print_chart_type_info(chart_type)}}{Print settings and color information for a given chart type
\describe{
  \item{chart_type}{the name for a chart type in R (e.g., 'BlocksTrack', 'StackedLineTrack')}
}}

\item{\code{register_chart_type(
  chart_type,
  js_chart_type = paste0("epiviz.plugins.charts.", chart_type),
  js_chart_settings = list(),
  js_chart_colors = character()
)}}{Register a chart type name to a JavaScript chart type in the epiviz app.
\describe{
  \item{chart_type}{the name to use for chart type in R (e.g., 'BlocksTrack')}
  \item{js_chart_type}{the full JavaScript class name of the corresponding chart type 
    (e.g. 'epiviz.plugins.charts.BlocksTrack'). If missing it is taken from the \code{chart_type} argument}
  \item{js_chart_settings}{custom settings that can be applied to this chart type in JS.}
  \item{js_chart_colors}{default color palette applied to this chart type in JS.}
}}

\item{\code{revisualize(chart_type, chart, ...)}}{Revisualize uses data the given chart and replots it in the given chart type. The argument \code{chart} must be non-\code{NULL}.
\describe{
\item{chart_type}{a chart type registered using the \code{register_chart_type} method}
\item{chart}{a chart that includes measurements to be used in a new chart}
}}

\item{\code{rm_all_charts()}}{Remove all charts loaded by chart manager.}

\item{\code{rm_chart(chart_object_or_id)}}{Remove chart from chart manager.
\describe{
 \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
   string indicating the chart's id assigned by chart manager}
}}

\item{\code{set_chart_settings(chart_object_or_id, settings = NULL, colors = NULL)}}{Apply custom chart settings or colors to a chart object.

\describe{
  \item{chart_object_or_id}{An object of class \code{\link{EpivizChart}} or a 
    string indicating the chart's id assigned by chart manager}
  \item{settings}{a list of settings to apply to the chart}
  \item{colors}{a list of (HEX code) colors to use in the chart}
}}

\item{\code{visualize(
  chart_type,
  measurements = NULL,
  datasource = NULL,
  settings = NULL,
  colors = NULL,
  send_request = TRUE,
  ...
)}}{Visualize data use the given chart type. One of arguments \code{measurements} or \code{datasource} must be non-\code{NULL}. If \code{measurements}
is \code{NULL}, the \code{get_measurements} method in class \code{\link{EpivizData}}
is used to decide which measurements are used in the chart

\describe{
  \item{chart_type}{a chart type registered using the \code{register_chart_type} method}
  \item{measurements}{a list of \code{\link{EpivizMeasurement}} objects
    describing measurements to include in the chart}
  \item{datasource}{an object of class \code{\link{EpivizData}}, all available
    measurements from datasource are used as appropriate}
}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/restartEpiviz.R
\name{restartEpiviz}
\alias{restartEpiviz}
\title{Restart epiviz app connection and workspace.}
\usage{
restartEpiviz(file, open_browser = TRUE, host = NULL, envir = parent.frame())
}
\arguments{
\item{file}{(character) The name of the file that holds the EpivizApp object to be restarted, ending in .rda.}

\item{open_browser}{(logical) browse to the epiviz URL before exiting function.}

\item{host}{(character) name of epiviz app host to open at restart}

\item{envir}{(environment) environment in which to evaluate expressions needed to reconstruct data sources}
}
\value{
An object of class \code{\link{EpivizApp}}
}
\description{
Restart epiviz app connection and workspace.
}
\examples{
# see package vignette for example usage
app <- startEpiviz(non_interactive=TRUE, open_browser=TRUE)
file_name <- tempfile(fileext=".rda")
app$save(file=file_name)
app$stop_app()

app <- restartEpiviz(file=file_name, open_browser=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EpivizChart-class.R
\docType{class}
\name{EpivizChart-class}
\alias{EpivizChart-class}
\alias{EpivizChart}
\title{Class encapsulating a chart in epiviz app}
\description{
Class encapsulating a chart in epiviz app
}
\section{Methods}{

\describe{
\item{\code{get_app_id(id)}}{Get chart's id assigned by epiviz app.}

\item{\code{get_colors()}}{Get color palette applied to the chart.}

\item{\code{get_id()}}{Get chart's id assigned by chart manager}

\item{\code{get_measurements()}}{Get measurements for the chart.}

\item{\code{get_settings()}}{Get custom settings for the chart.}

\item{\code{get_source_name()}}{Get chart's id assigned by chart manager}

\item{\code{is_connected()}}{Returns \code{TRUE} if chart is connected to a chart on epiviz app.}

\item{\code{print_info()}}{Print settings and color currently used in chart object.}

\item{\code{set(settings = NULL, colors = NULL)}}{Set settings and colors used in chart.
  \describe{
    \item{settings}{List of settings to apply.}
\item{colors}{Character vector of HEX colors to use in chart.}
  }}

\item{\code{set_app_id(id)}}{Set chart's id assigned by epiviz app.}

\item{\code{set_colors(colors)}}{Set custom colors for the chart.}

\item{\code{set_id(id)}}{Set chart's id assigned by chart manager.}

\item{\code{set_settings(settings)}}{Set custom settings for the chart. Returns subset of valid settings.
\describe{
  \item{settings}{List of settings to apply.}
}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EpivizApp-class.R
\docType{class}
\name{EpivizApp-class}
\alias{EpivizApp-class}
\alias{EpivizApp}
\title{Class managing connection to epiviz application.}
\description{
Class managing connection to epiviz application.
}
\section{Fields}{

\describe{
\item{\code{server}}{An object of class \code{\link{EpivizServer}} used to communicate with epiviz app.}

\item{\code{data_mgr}}{An object of class \code{\link{EpivizDataMgr}} used to serve data to epiviz app.}

\item{\code{chart_mgr}}{An object of class \code{\link{EpivizChartMgr}} used to manage charts added to epiviz app session.}
}}

\section{Methods}{

\describe{
\item{\code{get_current_location(callback)}}{Obtain current genome location on epiviz app and evaluate callback
function on result.

\describe{
  \item{callback}{A callback function to evaluate on response data. 
    Response data will be a list with slots \code{seqName}, \code{start}
    and \code{end}}
}}

\item{\code{get_ms_object(chart_id_or_object, index = 1)}}{Get object of class \code{\link[epivizrData]{EpivizData}} used as a data source
in a given chart.

\describe{
  \item{chart_id_or_object}{An object of class \code{EpivizChart} or an id for
    a chart loaded to the epiviz app.}
  \item{index}{Index into \code{.measurements}} list of chart object to obtain data object for.
}}

\item{\code{is_server_closed()}}{Check if underlying server connection is closed.}

\item{\code{load_remote_measurements()}}{Load remote measurements into R session.}

\item{\code{load_workspace(workspace_id = NULL)}}{load an epiviz workspace.

    \describe{
      \item{workspace_id}{Workspace id to load from the database.}
    }}

\item{\code{navigate(chr, start, end)}}{Navigate to given position on the epiviz app.}

\item{\code{plot(
  data_object,
  datasource_name = NULL,
  send_request = TRUE,
  settings = NULL,
  colors = NULL,
  ...
)}}{Visualize data on epiviz app using its default chart type. Measurements from the \code{data-object} 
are first added to the epiviz app using the \code{add_measurements} method for class 
\code{\link[epivizrData]{EpivizData}}. See documentation for \code{\link[epivizrData]{register}}
for information on supported data types and the \code{\link[epivizrData]{EpivizData}} class
encapsulating this type of data. Once measurements are loaded, the \code{\link{plot}} method
of class \code{\link{EpivizChartMgr}} is used to plot the data, using the default chart type
for this type of data.

\describe{
  \item{data_object}{An object to plot in epiviz app.}
  \item{datasource_name}{Name to use for datasource, parses \code{data_object} if missing or NULL}
  \item{...}{Additional arguments passed to \code{add_measurements} method for class
    \code{\link[epivizrData]{EpivizData}}}
}}

\item{\code{print_workspace(file_name = NULL, file_type = "pdf")}}{Save epiviz workspace as a pdf or png.}

\item{\code{save(file, include_data = TRUE)}}{Save EpivizApp object representation of a workspace into .RData file.

    \describe{
      \item{file}{(character) The name of the file to save the EpivizApp object into, ending in .rda.}
      \item{stop_app}{(logical) Stop the EpivizApp session.}
      \item{include_data}{(logical) Include EpivizApp's data when saving the EpivizApp object.}
    }}

\item{\code{service(verbose = TRUE)}}{Block interactive R session to service websocket requests.}

\item{\code{slideshow(granges, n = length(granges), .callback = NULL)}}{Navigate on epiviz app successively to given positions.

\describe{
  \item{granges}{An object of class \code{\link{GenomicRanges}} indicating
    set of genomic regions to navigate in epiviz app.}
  \item{n}{(integer) The number of regions in \code{granges} to navigate to.}
  \item{.callback}{(function) function to call after navigating to each region. Used for testing purposes.}
}}

\item{\code{stop_app()}}{stop and clean connection to epiviz app.}
}}
